/// <reference path="https://ajax.googleapis.com/ajax/libs/jquery/2.0.3/jquery.js"/>
/// <reference path="/core/js/cm.utils.js"/>
/// <reference path="/core/js/cm.data.js"/>
/// <reference path="/core/js/cm.date.js"/>
/// <reference path="/core/js/cm.jquery.js"/>
/// <reference path="/core/js/cm.system.js"/>
/// <reference path="/core/js/cm.remote.js"/>
/// <reference path="/core/js/cm.plugins.notify.js"/>
/// <reference path="/core/js/cm.plugins.page.js"/>
/// <reference path="/core/js/cm.plugins.lookup.js"/> 
/// <reference path="/core/js/cm.plugins.form.js"/>
/// <reference path="/core/js/cm.plugins.listview.js"/>

/**
 * The MyModule Module.
 * Replace(global) 'myapp' with the server side folder name (lowercase) where this file is located.
 * Replace(global) 'MyModule' with the name of this module file (except the first letter is capitalised here), this is also the same as the name of the server side aspx file.
 * This file may contain additional classes that are either associated with this module or are supporting additional views in the markup file
 */
(function ($) {
    "use strict";

    var schedule = $.namespace("wj.modules.projects.schedule", true);

    schedule.edit2 = function (view) {
        var self = new Module(view, 'Modules.Projects.Schedule'); //FQN.OF.SERVER.CLASS Without the WJAPP, add WJ if you need WJ
        var ds = self.model;
        var dp = ds.dp;
        var options = {};
        var key = 0;

        var arrScheduleConstraintDayOfWeek;
        var arrSchedulePriority;
        var zoomLevel = 'DAY';
        var arrZoomLevel;
        var colsSettings;
        var widthSettings;
        var lockedColsSettings;
        var arrScheduleConstraints;
        var arrScheduleConstraints2;
        var gridExpanded = true;
        var companyIdleDay = {};
        var personalIdleDay = {};
        var store;
        var searchKeys;
        var scheduleParms;
        var buckets = [];
        var previousMonday;
        var retainerBuckets;
        var retainerActuals;
        var sendingProjectNotifications;
        var notifySelectedTaskKeys;

        //gantt variables
        var minorScale = [];
        var majorScale = [];
        var intervals = [];
        var minimalDaysInFirstWeek = 3;
        var zoomLevel = 'DAY';
        var rangeStartDateLast;
        var rangeEndDateLast;
        var ppd;
        var arrZoomLevel = [];
        var indentWidth = 0.1;

        //lists to use when switching on the assignment pop up
        var users;
        var services;
        var userServices;

        function load(pageAction) {
            //the init object
            options = pageAction.options || {};
            key = pageAction.k;
            //init the module
            //create the modules list

            ds.createList('scheduleTasks:TaskKey,predecessors:TaskPredecessorKey,conversations:ActivityKey,files,attachments:AttachmentKey,convAttachments:AttachmentKey,toAssignList:UserKey,todoItems:ActivityKey,taskUsers:TaskUserKey,scheduleConstraints:k,scheduleConstraints2:k,schedulePriority:k,scheduleConstraintDayOfWeek:k,selectedTemplateTasks:TaskKey,templateTaskUsers,templateTaskPreds,zoomLevel,colSets:GridColSetKey,assignedTo:AssignedToKey,reassignedTo:ReassignToKey,activityStatus:k,predTaskLookup:k,reassignTasks:TempKey,reassignTasksOnly:TempKey,summaryTasks:TaskKey,originalTasks:TaskKey,projectUsers:UserKey,projectService:ServiceKey');
            /////,updatedTasks:TaskKey,updatedPredecessors:TaskPredecessorKey
            ds.createItem('project,template,searchTasks,printSettings,displayOptions,copyProjectOptions,reassignment,searchAssigned,addAssignmentToSelectedTasks');
            dp.add('hasCustomizationWeeklySchedule,hasCustomizationConcentric,hasCustomizationBSSAndP,hasCustomizationResourceBucket,projectScheduleEditable,sideAction,autoIDTasks,showTemplateDropBox,showConstraintDate,isTemplate,settingID,resetData,showPrintScheduleOptions,showPrintScheduleGridOptions,showPrintClientScheduleOptions,showInitialsOnly,showPrintGanttOptions,hideplugin,showDetail');
            dp.add('showLoading,showBuckets,showDetails,showAssignmentDropBox,showAddServiceAssignments,showHideTheSidebar,showRetainerSidebar,assignmentTab,addAssignmentTab,showCrossProjectPreds, activeOption,scheduleTaskEditable,hasCustomizationAbelson,crossProjectQueueWait,addedToQueue,showAssignAllTasks');
            dp.add('isRetainer,approvedEstimateCount,estimateCount,estimateKey,showLinkToAbove,showLinkToAboveHover'); // for retainers and their estimates

            ds.toAssignList.setFilter({ mode: 'input', type: 'inc', fields: 'Label' });

            self.subscribe('refreshSettings', function (item) {
                if (u.obs(item.groupID) === 'projectTemplate' || u.obs(item.groupID) === 'projectSchedule') {
                    System.loaded.ProjectSchedule = false;
                    loadModule();
                }
            });

            self.subscribe('changeColumnSets', function (list) {
                if (list.length) {
                    for (var i = 0; i < list.length; i++) {
                        list[i].k = list[i].GridColSetKey;
                        list[i].l = list[i].SetName;
                    }
                    list.unshift({ k: 0, l: System.localize('|24977|Default Layout|') });
                }

                ds.colSets.source = list;
                ds.colSets.refresh();

                var colSet = ds.colSets.findByKey(u.obn(System.session.projectSchedule.colSetKey));
                if (!colSet) {
                    colSet = { GridColSetKey: 0, SetName: System.localize('|24977|Default Layout|') };
                }
                System.session.projectSchedule.colSetKey = colSet.GridColSetKey;
                ds.searchTasks.source = colSet;
                if (System.session.projectSchedule.colSetKey === 0) {
                    view.grids.grdProjectSchedule.columns = 'prjScheduleTask,' + System.session[dp.settingID][colsSettings];
                } else {
                    view.grids.grdProjectSchedule.columns = 'prjScheduleTask,' + ds.colSets.findByKey(System.session.projectSchedule.colSetKey).Columns;
                }

            });

            self.subscribe('deferredScheduleValidationNotification', function (item) {
                Notify.alert(item);
                ds.scheduleTasks.fire();
            });
            self.subscribe('production.refreshList', function() { loadConversations(); });
            self.subscribe('conversationUpdated', function() { loadConversations(); });
            self.subscribe('todoUpdated', loadToDos);
            self.subscribe('estimateUpdated', function () {refreshEstimateStatus();  });
            self.subscribe('estimateDeleted', function () { refreshEstimateStatus(); });
            self.subscribe('estimateStatusChanged', function () { refreshEstimateStatus(); });

            self.subscribe('predEditSave', function (list) {

                var newKeys = [];
                var lagValues = {};
                var taskKey;
                for (var i = 0; i < list.length; i++) {
                    if(list[i].tagged === 1){
                        taskKey = u.obn(list[i].TaskKey).toString();
                        newKeys.push(taskKey);
                        if (list[i].Lag !== 0) {
                            lagValues[taskKey] = list[i].Lag;
                        }
                    }
                }
                ds.scheduleTasks.si.AssignedPredsKeys = newKeys.join(',');
                fieldChangeHandler(ds.scheduleTasks.si, ds.scheduleTasks, 'field', 'AssignedPreds');

                //after the predecessor has been added, set its Lag value
                var preds = ds.predecessors.findByKey(ds.scheduleTasks.si.TaskKey, 'TaskKey');
                if (!Array.isArray(preds)) {
                    preds = [preds];
                }
                for (taskKey in lagValues) {
                    for (var i = 0; i < preds.length; i++) {
                        if (preds[i].PredecessorKey === u.obn(taskKey)) {
                            preds[i].Lag = u.obn(lagValues[taskKey]);
                            fieldChangeHandler(preds[i], ds.predecessors, 'field', 'Lag');
                        }
                    }
                }
            });

            store = ds.getStorage() || {};

            ds.selectedTemplateTasks.addHDD('TaskKey', 'SummaryTaskKey');

            ds.scheduleTasks.options.tagOrder = 1;
            ds.scheduleTasks.options.trans = true;
            ds.scheduleTasks.options.ignoreFields =
                {
                    buckets: true, original: true, tuhTaskParms: true, AssignedPreds: true, Assigned: true, TrackBudgetEditRestricted: true, TotalActualHours: true, taskUsers: true, AssignedPredsKeys: true, predecessors: true,
                    scheduled: true, scheduleOrder: true, maxDate: true
                };


            dp.showTemplateDropBox = false;
            dp.autoIDTasks = false;
            dp.showAddServiceAssignments = false;
            dp.showHideTheSidebar = true;
            dp.showLoading = true;
            dp.addAssignmentTab = dp.assignmentTab = 'task';
            dp.showDetails = true;

            dp.showLinkToAboveHover = calcLinkToAboveDisplay;

            //add the HDD - as normal
            var hdd = ds.scheduleTasks.addHDD('TaskKey', 'SummaryTaskKey');
            hdd.displayOrder.listOrder = 'ProjectOrder';
            hdd.displayOrder.nodeOrder = 'DisplayOrder';
            hdd.displayOrder.nodeLevel = 'TaskLevel';
            hdd.displayOrder.fill = 'auto';
            hdd.displayOrder.base = 1;
            hdd.displayOrder.update = updateTaskID;//called whenever the framework reindexes the structure

            ds.scheduleTasks.setFilter({ mode: 'input', type: 'inc', fields: 'TaskID,TaskName' });
            ds.scheduleTasks.options.filter.f = taskFilter;

            //setup assignment tasks
            hdd = ds.reassignTasks.addHDD('TempKey', 'SummaryTaskKey');
            hdd.displayOrder.listOrder = 'SortOrder';
            hdd.displayOrder.nodeOrder = 'DisplayOrder';
            hdd.displayOrder.nodeLevel = 'TaskLevel';
            hdd.displayOrder.fill = 'auto';
            hdd.displayOrder.base = 1;

            hdd = ds.reassignTasksOnly.addHDD('TempKey', 'SummaryTaskKey');
            hdd.displayOrder.listOrder = 'SortOrder';
            hdd.displayOrder.nodeOrder = 'DisplayOrder';
            hdd.displayOrder.nodeLevel = 'TaskLevel';
            hdd.displayOrder.fill = 'auto';
            hdd.displayOrder.base = 1;

            view.addGrid('grdProjectSchedule');
            view.addGrid('grdToDos');
            view.addGrid('grdPreds');
            //now add an HD 'list' and customise the returned HDD object by setting or own custom display formatter
            //this assumes 'taskUsers' and 'scheduleTasks' are linked on 'scheduleTasks' PK which is 'TaskKey'
            //and that the children will be stored in a property 'taskUsers' on the Task and sourced from a ds also called 'taskUsers'
            // we can change any of those properties if we like
            // for clarity the longer form is: childLinkField, parentLinkField, childrenField, source
            // var hdd = ds.scheduleTasks.addHDD('TaskKey', 'TaskKey', 'taskUsers', 'taskUsers');
            // hdd.displayFormatter = formatAssignedSchedule;

            ds.taskUsers.setParent(ds.scheduleTasks, 'TaskKey', 'TaskKey');
            ds.scheduleTasks.addHDD('taskUsers', 'list').displayFormatter = formatAssignedSchedule;
            ds.taskUsers.options.batchMode = true;
            ds.taskUsers.options.hideDeletes = true;
            ds.taskUsers.options.trans = true;
            ds.taskUsers.options.ignoreFields = appendOffsetIgnoreFields(
                {
                    original: true
                });

            ds.predecessors.setParent(ds.scheduleTasks, 'TaskKey', 'TaskKey');
            ds.scheduleTasks.addHDD('predecessors', 'list').displayFormatter = formatPredecessorSchedule;
            ds.predecessors.options.batchMode = true;
            ds.predecessors.options.hideDeletes = true;
            ds.predecessors.options.trans = true;
            ds.predecessors.options.ignoreFields =
                {
                    PredPlanComplete: true,
                    PredPlanDuration: true,
                    ProjectKey: true,
                    ProjectName: true,
                    ProjectNumber: true,
                    ProjectOrder: true,
                    TaskFullName: true,
                    TaskID: true,
                    TaskName: true
                };

            ds.todoItems.setParent(ds.scheduleTasks, 'TaskKey', 'TaskKey');
            ds.conversations.setParent(ds.scheduleTasks, 'TaskKey', 'TaskKey');
            ds.conversations.addHDD('ActivityKey', 'EntityKey', 'convAttachments', 'list');
            ds.attachments.setParent(ds.scheduleTasks, 'TaskKey', 'TaskKey');

            //add a kbd shortcut scope - ctl id and description (for help panel)

            ds.scheduleTasks.options.checkAllChildren = false;
            ds.scheduleTasks.options.batchMode = true;
            ds.scheduleTasks.options.hideDeletes = true;

            ds.reassignTasks.options.batchMode = true;

            var scope = Key.addScope(view, 'grdProjectSchedule', 'Grid Project Schedule');

            //now add the key bindings - scope, accesskey, action, description
            Key.bindKey(scope, 'ctrl+right', 'moveTaskIn', System.localize('|24169|Push Right|'));//moveTaskIn
            Key.bindKey(scope, 'ctrl+left', 'moveTaskOut', System.localize('|24168|Push Left|'));//moveTaskOut
            Key.bindKey(scope, 'ctrl+d', 'duplicateTask', System.localize('|24170|Duplicate|'));//D
            Key.bindKey(scope, 'ctrl+i', 'insertBelowTask', System.localize('|24256|Insert below|'));//I
            Key.bindKey(scope, 'ctrl+backspace', 'delete', System.localize('|24257|Delete Task|'));//I
            //press ? to see help panel

            arrSchedulePriority = [{ k: 1, l: "|24258|High|" }, { k: 2, l: "|24259|Medium|" }, { k: 3, l: "|24260|Low|" }];
            arrScheduleConstraintDayOfWeek = [{ k: 0, l: "|24261|Any Day|" }, { k: 1, l: "|24262|Sunday|" }, { k: 2, l: "|24263|Monday|" }, { k: 3, l: "|24264|Tuesday|" }, { k: 4, l: "|24265|Wednesday|" }, { k: 5, l: "|24266|Thursday|" }, { k: 6, l: "|24267|Friday|" }, { k: 7, l: "|24268|Saturday|" }];
            arrZoomLevel = [{ k: 1, l: "|24269|Day|", zoom: 2900000 }, { k: 2, l: "|24270|Week|", zoom: 10800000 }, { k: 3, l: "|24271|Month|", zoom: 50400000 }];
            view.addGrid('grdProjectTemplate');

            //reasign panel
            ds.reassignedTo.sortOn("SortOrder,l");
            ds.assignedTo.sortOn("SortOrder,l");

            return loadModule();
        }

        function appendOffsetIgnoreFields(ignoreList) {

            for (var i = 0; i <= 100; i++) {
                ignoreList['Offset_' + i.toString()] = true;
            }
            return ignoreList;
        }


        /**
        * Some Server method
        * @param param1
        * @param param2
        * @returns {jQuery.Deferred}
        */
        function loadModule(initialized) {
            return self.remoteDataCall('initSchedule', { loaded: System.loaded.ProjectSchedule, ProjectKey: key }, function (results) {

                if (results.errors) {
                    Notify.error(results.errors[0].message);
                } else {
                    //set the page title
                    Views.setTitle(view, u.obs(results.data.project.ProjectNumber, '') + '-' + u.obs(results.data.project.ProjectName, ''));

                    if (!System.loaded.ProjectSchedule) {
                        //load in rights and preferences
                        System.webdavInit = results.data.webdavInit;
                        System.addUserSettings(results.data.init);
                        System.loaded.ProjectSchedule = true;
                    }
                    dp.sideAction = System.session.projectSchedule.sideAction || 'details';
                    dp.activeOption = System.session.projectSchedule.IncludeProjects === 1 ? 0 : 5; //  0 = All, 5 = Template
                    dp.showHideTheSidebar = (u.obs(dp.sideAction, 'none') !== 'none');
                    ds.project.source = results.data.project;

                    //used by the user lookups on the reassignment panel
                    ds.reassignment.source = {ProjectKey: key};
                    ds.addAssignmentToSelectedTasks.source = {ProjectKey: key};
  
                    if (u.obs(ds.project.si.StartDate) && u.obs(ds.project.si.CompleteDate)) {
                        ds.project.source.ProjectDates = 'Project Dates: ' + Date.formatDate(ds.project.source.StartDate, 'd') + ' - ' + Date.formatDate(ds.project.source.CompleteDate, 'd');
                    } else { // one of them is blank
                        if (u.obs(ds.project.si.StartDate)) { // CompleteDate is blank
                            ds.project.source.ProjectDates = 'Project Start Date: ' + Date.formatDate(ds.project.source.StartDate, 'd');
                        } else { //StartDate is blank
                            ds.project.source.ProjectDates = 'Project Complete Date: ' + Date.formatDate(ds.project.source.CompleteDate, 'd') ;
                        }
                    }

                    dp.isTemplate = (ds.project.si.Template === 1);
                    dp.settingID = dp.isTemplate ? 'projectTemplate' : 'projectSchedule';

                    colsSettings = dp.isTemplate ? 'grdProjectTemplateCols' : 'grdProjectScheduleCols';
                    widthSettings = dp.isTemplate ? 'grdProjectTemplateWidths' : 'grdProjectScheduleWidths';
                    lockedColsSettings = dp.isTemplate ? 'TemplateLockedColumns' : 'ScheduleLockedColumns';

                    if (results.data.colSets.length && !dp.isTemplate) {
                        var defSet = System.localize('|24977|Default Layout|');
                        results.data.colSets.unshift({ k: 0, l: defSet });
                        ds.colSets.source = results.data.colSets;
                        ds.colSets.refresh();
                        var colSet = ds.colSets.findByKey(u.obn(System.session.projectSchedule.colSetKey));
                        if (!colSet) {
                            colSet = { GridColSetKey: 0, SetName: defSet };
                        }
                        System.session.projectSchedule.colSetKey = colSet.GridColSetKey;
                        ds.searchTasks.source = colSet;
                    } else {
                        System.session.projectSchedule.colSetKey = 0;
                    }

                    if(System.prefs.UseStatusOnToDo === 1){
                        ds.todoItems.group(GroupField('StatusName:aai', 'todo', 'ActivityKey'));
                    }else{
                        ds.todoItems.group(GroupField('CompletedName:aai', 'todo', 'ActivityKey'));
                    }


                    dp.autoIDTasks = u.obb(ds.project.si.AutoIDTask);

                    // Customizations.
                    dp.hasCustomizationBSSAndP = System.hasCustomization('bssandp');
                    dp.hasCustomizationConcentric = System.hasCustomization('concentric');
                    dp.hasCustomizationWeeklySchedule = System.hasCustomization('weeklySchedules');
                    dp.hasCustomizationResourceBucket = System.hasCustomization('resourceBucket');
                    dp.hasCustomizationAbelson = System.hasCustomization('abelson');
                    dp.hideplugin = u.obb(System.session.projectSchedule.showGantt, false);
                    dp.showdetail = u.obb(System.session.projectSchedule.showDetail, false);
                    //dp.crossProjectButton = System.prefs.CrossProjectPreds === 1 && !u.obb(results.data.crossProjectPredsExists);
                    dp.showCrossProjectPreds = System.prefs.CrossProjectPreds === 1 // && u.obb(results.data.crossProjectPredsExists);

                    ds.schedulePriority.source = System.localize(arrSchedulePriority);
                    ds.scheduleConstraintDayOfWeek.source = System.localize(arrScheduleConstraintDayOfWeek);
                    ds.zoomLevel.source = System.localize(arrZoomLevel);
                    ds.activityStatus.source = results.data.activityStatus;

                    // always add Task Name because we want it locked in first position
                    if (System.session.projectSchedule.colSetKey === 0) {
                        view.grids.grdProjectSchedule.columns = 'prjScheduleTask,' + System.session[dp.settingID][colsSettings];
                        //view.grids.grdProjectSchedule.columns = 'prjScheduleTask,prjDisplayOrder,prjTaskType,prjLevel,' + System.session[dp.settingID][colsSettings];
                    } else {
                        view.grids.grdProjectSchedule.columns = 'prjScheduleTask,' + ds.colSets.findByKey(System.session.projectSchedule.colSetKey).Columns;
                    }
                    dp.defaultCols = 'prjScheduleTask,' + System.session[dp.settingID][colsSettings];
                    view.grids.grdProjectSchedule.widths = System.session[dp.settingID][widthSettings];
                    view.grids.grdProjectSchedule.locked = parseInt(System.session[dp.settingID][lockedColsSettings]);
                    view.grids.grdProjectSchedule.overrides.pluginSize = System.session.projectSchedule.grdProjectScheduleGanttPanelSize || '';
                    ds.printSettings.source = { ProjectKey: key, PrintOption: 1 };
                    ListViews.showTab(view, u.obs(System.session.projectSchedule.detailTab, 'tabEdit'));

                    u.getBlockoutDays(loadSchedule, self, blockoutDaysRefreshed, false, true);

                    updateEditableState();
                    loadTemplates();
                    loadAttachments();

                }
            });
            //regardless of method you must return to the source.
        }

        function blockoutDaysRefreshed(blockoutDays) {
            if (scheduleParms) {
                //This will cause the schedule to recalculate the dates after the blockout days have been refreshed
                var resp = Schedule.refreshSchedule(scheduleParms, blockoutDays);
                processScheduleErrors(resp);
                initTaskSettings();
            }
        }

        /**
         * Takes the response from the Schedule class and displays any errors or notifications
         * @param resp Response object
         * @returns {boolean} Returns false if there were errors in the response.
         */
        function processScheduleErrors(resp) {

            var errors = resp.generalErrors;
            var notifications = resp.generalNotifications;

            if (errors) {
                if (errors.length > 0) {
                    Notify.error(Array(errors).join('\n'));
                    return false;
                }
            }

            if (notifications) {
                if (notifications.length > 0) {
                    var arr = [];
                    for (var i = 0; i < notifications.length; i++) {
                        arr.push(notifications[i].msg);
                    }
                    Notify.alert(Array(arr).join('\n'));
                }
            }
            return true;
        }

        function processCrossProjectQueue(addedToQueue) {

            updateEditableState(true); //force read only

            dp.crossProjectQueueWait = true;
            dp.addedToQueue = 'This schedule is in a cross-project predecessor relationship and was added to the queue to be rescheduled at ' + formatValue('dt', addedToQueue) + '. The rescheduling should be completed within 3 minutes. This schedule will load once it has been rescheduled.';
            //Notify.showBusy("This schedule is in a cross-project predecessor relationship and is in the queue to be rescheduled within 2 minutes. This schedule will attempt a reload in 1 minute.", true);
            startTimer();
        }

        var timerCount;

        function startTimer() {
            timerCount = 0;
            System.setTimer(self, 'scheduleCrossProject', true, timerTick, 500); //tick every 5 seconds to advance the progress bar
        }
        function stopTimer() {
            System.clearTimer(self, 'scheduleCrossProject');
        }
        function timerTick() {
            timerCount++;
            if(timerCount >= 119){
                stopTimer();
                Notify.hideBusy();
                u.getBlockoutDays(loadSchedule, null, null, false, true, true); //this will cause the blockoutDays to be passed into loadSchedule
                updateEditableState();
                return;
            }
            Notify.updateProgress((timerCount / 120) * 100);
        }

        function loadSchedule(blockoutDays) {

            Notify.showBusy();
            ds.scheduleTasks.loading();
            return self.remoteDataCall('getSchedule', {projectKey: key, searchKeys: searchKeys, includeTransactions: true, loadBucketDetail: true, application: 'scheduleEdit getSchedule', performRecalc: false}, function (results) {

                dp.isRetainer = u.obb(results.data.isRetainer);
                dp.estimateCount = u.obn(results.data.hasEstimates); // this is also a count of estimate
                dp.approvedEstimateCount = u.obn(results.data.hasApprovedEstimates);
                dp.estimateKey = u.obn(results.data.estimateKey); // if only 1 estimate, go directly to it
                dp.showBuckets = dp.isRetainer || store.scheduleShowBuckets;
                ds.scheduleTasks.source = setupRollupData(results.data.tasks);
                ds.predecessors.source = results.data.predecessorData;
                ds.taskUsers.source = results.data.projectTaskUserData;
                dp.showLoading = false;

                if(dp.isRetainer && ds.taskUsers.source.length === 0){
                    dp.showRetainerSidebar = true;
                }

                var item;
                var isCrossProject = false;
                var predKeyMap = {};
                for (var i = 0; i < results.data.predecessorData.length; i++) {
                    item = results.data.predecessorData[i];
                    if (item.CrossProject === 1) {
                        isCrossProject = true;
                    }
                    if (predKeyMap[item.TaskKey]) {
                        predKeyMap[item.TaskKey] += ',' + u.obs(item.PredecessorKey);
                    } else {
                        predKeyMap[item.TaskKey] = u.obs(item.PredecessorKey);
                    }
                }

                for (var i = 0; i < ds.scheduleTasks.source.length; i++) {
                    item = ds.scheduleTasks.source[i];
                    if(predKeyMap[item.TaskKey]){
                        item.AssignedPredsKeys = predKeyMap[item.TaskKey];
                    }
                }

                setShowTemplateDropBox();

                ds.displayOptions.si.OpenExpanded = u.obn(System.session.projectSchedule.OpenExpanded);
                if (u.obn(System.session.projectSchedule.OpenExpanded) === 0) {
                    view.grids.grdProjectSchedule.collapseAll();
                    gridExpanded = false;
                }

                view.grids.grdProjectSchedule.selectable = dp.projectScheduleEditable;
                Notify.hideBusy();

                getTrackBudgetRestriction(); //get these in the background because it requires a lot of queries, if someone edits TrackBudget before this comes back, it's OK, it'll be caught on the server
                loadToDos(); //just load ToDos in the background and then update the rows
                loadConversations();
                loadToAssign();

                //Call initScheduleParms and pass in all of the relevant datasources and other data.
                //This will create a scheduleParms object that is then passed back into Schedule for every call that is made (very similar to ItemRateManager)
                //Make sure System.prefs has ActualDateUpdatesPlan,AutoScheduleProjects,AutoScheduleTaskEndDate loaded first!
                scheduleParms = Schedule.initScheduleParms(ds.scheduleTasks, ds.predecessors, ds.taskUsers, ds.project.si, blockoutDays, System.prefs, results.data.users, {retainer: dp.isRetainer});

                if (isCrossProject){

                    var crossProjectPreds = results.data.predecessorData.filter(function (item){
                        return item.CrossProject === 1;
                    });

                    var cpItem;
                    for(var cpp = 0; cpp < crossProjectPreds.length; cpp++){
                        cpItem = crossProjectPreds[cpp];
                        Schedule.addCrossProjectPredInformation(scheduleParms, cpItem.PredecessorKey, cpItem.PredPlanComplete, cpItem.PredPlanDuration);
                    }
                }

                //This tells the ScheduleManager which template predecessors and assignments go along with the template that is currently selected.
                //We need to call this every time a different template is selected, so that predecessors and assignments can be brought over correctly
                Schedule.setSelectedTemplate(scheduleParms, ds.templateTaskUsers, ds.templateTaskPreds);

                //This will format the predecessor key and label values for the SelectList control
                //Schedule.formatPredValues(scheduleParms);

                arrScheduleConstraints = scheduleParms.constraintList;
                arrScheduleConstraints2 = scheduleParms.constraintListWithDuration;
                initTaskSettings();

                //This loads up all of the schedule buckets in the background
                Schedule.initBuckets(scheduleParms);

                if(ds.scheduleTasks.source.length > 0){
                    //the "select" event may have already fired before the bucket information was loaded.
                    //therefore, call calcColumns again on the first row to make sure that the bucket columns are calculated correctly
                    calcColumns(true, ds.scheduleTasks.source[0]);
                }

                if (dp.isRetainer) {
                    previousMonday = results.data.previousMonday;
                    retainerBuckets = results.data.retainerBuckets;
                    retainerActuals = results.data.retainerActuals;
                    setupRetainerData(ds.scheduleTasks.source[0], results.data.projectTaskUserData);
                }

                if(results.data.isInCrossProjectQueue){
                    processCrossProjectQueue(results.data.addedToCrossProjectQueue);
                }else{
                    dp.crossProjectQueueWait = false;
                    Notify.hideBusy();

                    if(!dp.isRetainer && options.TaskKey > 0){
                        var taskItem = scheduleParms.findTaskByKey(options.TaskKey);
                        if(taskItem) {
                            ds.scheduleTasks.selectedItem = taskItem;
                            if(options.toDoTab){
                                actionTopicHandler(null, {action: 'sideAction', actionKey: 'details'});
                                var aTab = ListViews.getActiveTab(view, 'tabMain');
                                if(aTab){
                                    if(aTab.id !== 'tabToDo'){
                                        ListViews.showTab(view, 'tabToDo');
                                    }
                                }
                            }else {
                                //don't open the assignment panel, but still highlight the task
                                //openAssignmentPanel(options.TaskKey);
                            }
                        }
                    }
                }
            });
        }

        function setupRetainerData(task, taskUsers, clearBucketData, newRetainerBuckets, newRetainerActuals) {

            var item;
            var taskUserKey;
            var bucketList;
            var actualsList;
            var field;
            var bucketCount;
            var retainerHours;
            var retainerKey = ds.project.si.RetainerKey;

            if (task && task.tuhTaskParms && task.tuhTaskParms.buckets) {
                bucketCount = task.tuhTaskParms.buckets.length;
            }

            for (var i = 0; i < taskUsers.length; i++) {
                item = taskUsers[i];
                item.RetainerKey = retainerKey;
                taskUserKey = item.TaskUserKey;

                if (newRetainerBuckets) {
                    bucketList = retainerBuckets.filter(filterTaskUserKey, taskUserKey);
                    for (var j = 0; j < bucketList.length; j++) {
                        retainerBuckets.splice(retainerBuckets.indexOf(bucketList[j]), 1);
                    }
                    retainerBuckets = retainerBuckets.concat(newRetainerBuckets);
                    bucketList = retainerBuckets.filter(filterTaskUserKey, taskUserKey);
                } else {
                    bucketList = retainerBuckets.filter(filterTaskUserKey, taskUserKey);
                }

                if (newRetainerActuals) {
                    actualsList = retainerActuals.filter(filterTaskUserKey, taskUserKey);
                    for (var j = 0; j < actualsList.length; j++) {
                        retainerActuals.splice(retainerActuals.indexOf(actualsList[j]), 1);
                    }
                    retainerActuals = retainerActuals.concat(newRetainerActuals);
                    actualsList = retainerActuals.filter(filterTaskUserKey, taskUserKey);
                } else {
                    actualsList = retainerActuals.filter(filterTaskUserKey, taskUserKey);
                }

                if (clearBucketData) {
                    for (var j = 0; j < bucketCount; j++) {
                        item['RetainerBucket_' + j.toString()] = null;
                        item['RetainerRemaining_' + j.toString()] = null;
                    }
                    return;
                }

                for (var j = 0; j < bucketCount; j++) {
                    item['RetainerBucket_' + j.toString()] = 0;
                }

                if (!clearBucketData) {
                    for (var j = 0; j < actualsList.length; j++) {
                        if (actualsList[j].BucketStart < previousMonday) {
                            field = 'RetainerBucket_' + actualsList[j].RetainerOffset;
                            item[field] = u.obn(item[field]) + actualsList[j].Hours;
                        }
                    }

                    for (var j = 0; j < bucketList.length; j++) {
                        if (bucketList[j].BucketStart >= previousMonday) {
                            field = 'RetainerBucket_' + bucketList[j].RetainerOffset;
                            item[field] = u.obn(item[field]) + bucketList[j].Hours;
                        }
                    }
                }

                retainerHours = 0;
                for (var j = 0; j < bucketCount; j++) {
                    item['RetainerRemaining_' + j.toString()] = u.obn(item['Offset_' + j.toString()]) - u.obn(item['RetainerBucket_' + j.toString()]);
                    retainerHours += u.obn(item['RetainerRemaining_' + j.toString()]);
                }
                item.RetainerHours = retainerHours;
            }
            ds.taskUsers.fire();
        }

        function setupReassignDS(taskUserData) {

            // to track what we have processed
            var processedUser = {};
            var processedService = {};
            // new general lookup data sorce
            var currentAssignedUserList = [];
            var currentAssignedServiceList = [];

            for (var i = 0; i < taskUserData.length; i++) {
                var currentAssignment = taskUserData[i];

                if (currentAssignment.UserKey != undefined) {
                    if (currentAssignment.UserKey > 0) {
                        if (!processedUser[currentAssignment.UserKey]) {
                            processedUser[currentAssignment.UserKey] = true;
                            var addedUser = {};
                            addedUser.k = u.obn(currentAssignment.UserKey);
                            addedUser.l = u.obs(currentAssignment.UserName);
                            addedUser.Initials = u.obs(currentAssignment.Initials);
                            currentAssignedUserList.push(addedUser);
                        }
                    }
                }
               
                if (currentAssignment.ServiceKey != undefined) {
                    if (currentAssignment.ServiceKey > 0) {
                        if (!processedService[currentAssignment.ServiceKey]) {
                            processedService[currentAssignment.ServiceKey] = true;
                            var addedService = {};
                            addedService.k = u.obn(currentAssignment.ServiceKey);
                            addedService.l = u.obs(currentAssignment.ServiceDescription);
                            addedService.ServiceDescription = u.obs(currentAssignment.ServiceDescription);
                            addedService.ServiceCode = u.obs(currentAssignment.ServiceCode);
                            currentAssignedServiceList.push(addedService);
                        }
                    }
                }
            }

            ds.projectUsers.source = currentAssignedUserList;
            ds.projectService.source = currentAssignedServiceList;

        }

        function filterTaskUserKey(item) {
            return item.TaskUserKey === this;
        }

        function getTrackBudgetRestriction() {
            return self.remoteDataCall('getTrackBudgetRestriction', { projectKey: key, tasks: ds.scheduleTasks.source }, function (results) {

                var tasks = results.data.tasks;
                var updateItem;
                var task;
                for (var i = 0; i < tasks.length; i++) {
                    task = tasks[i];
                    if (task) {
                        updateItem = ds.scheduleTasks.findByKey(task.TaskKey);
                        if(updateItem && updateItem.TrackBudget === 1) {
                            updateItem.TrackBudgetEditRestricted = task.TrackBudgetEditRestricted;
                        }
                    }
                }
                ds.scheduleTasks.refresh();
            });
        }

        var openText = System.localize('|24978|Open|');
        var completedText = System.localize('|24979|Completed|');
        function loadToDos() {
            if (System.prefs.UseToDo) {
                return self.remoteDataCall('loadScheduleToDos', { projectKey: key }, function (results) {
                    for (var i = 0; i < results.data.todos.length; i++) {
                        var item = results.data.todos[i];
                        //item.tagged = u.obn(item.Completed);
                        item.CompletedName = item.Completed ? completedText : openText;
                    }
                    ds.todoItems.source = results.data.todos;
                });

            }

        }
        function loadConversations() {
            if (System.rights.prjnotes) {
                return self.remoteDataCall('WJAPP.Modules.Projects.Production.getConversations', { Entity: 'tProject', EntityKey: key }, function (results) {
                    ds.conversations.source = results.data.diary;
                    ds.convAttachments.source = results.data.attachments;
                });

            }

        }
        function loadToAssign() {
            return self.remoteDataCall('loadPeopleAndServicesToAssign', { ProjectKey: key }, function (results) {
                services = results.data.services;
                users = results.data.users;
                userServices = results.data.userServices;
                ds.toAssignList.source = users;
            });

        }

        //additional function to hide based on percent complete.
        var hideCompleted;
        function taskFilter(item, idx, src) {
            //This has to return true to be seen
            if (hideCompleted) {
                return (!item.filter && item.PercComp !== 100) || item.rowstate.indexOf('I') >= 0;
            } else {
                return !item.filter || item.rowstate.indexOf('I') >= 0;
            }
        }
        /**
         * Helper function to format the assigned display field
         * When this is called the taskUsers field on the Task has already been populated
         * We only need to iterate that array property and build the display string
         * @param {Object} task a Task
         * @param {HDD} hdd the definition object for this HDList
         */
        function formatAssignedSchedule(task, hdd) {
            if (task) {
                var assignedNames = "";
                var taskUsers = task.taskUsers;
                if (taskUsers) {
                    var user;
                    for (var i = 0; i < taskUsers.length; i++) {
                        user = taskUsers[i];
                        if (user.rowstate !== 'D') {
                            if (assignedNames) assignedNames += ", ";
                            assignedNames += (user.UserKey ? user.Initials : user.ServiceCode);
                            if (user.Hours) assignedNames += " (" + Math.roundTo(user.Hours, 2).toString() + ")";
                        }
                    }
                }
                //we set this into any field we like - then use that field in the UI as normal
                task.Assigned = assignedNames;

                if(task === ds.scheduleTasks.si) {
                    setScheduleTaskEnabled();
                }
            }
        }

        function formatPredecessorSchedule(task, hdd) {
            if (task) {
                var selectedPredecessors = '';

                var predKeys = task.AssignedPredsKeys || '';
                var taskPredecessors = predKeys.split(',');
                var key;
                var item;
                var predTask;
                for (var i = 0; i < taskPredecessors.length; i++) {
                    key = taskPredecessors[i];

                    item = ds.predecessors.findByKey(u.obn(key), 'PredecessorKey');
                    if(Array.isArray(item)){
                        item = item.filter(function (item) {
                            return item.TaskKey === task.TaskKey;
                        });
                        if(item.length > 0){
                            item = item[0];
                        }else{
                            item = null;
                        }
                    }
                    if(item) {
                        if (selectedPredecessors) selectedPredecessors += ', ';

                        if (item.CrossProject === 1) {
                            selectedPredecessors = selectedPredecessors + u.obs(item.ProjectNumber).replace(',', '_') + ': ' + item.ProjectOrder;
                        } else {
                            predTask = ds.scheduleTasks.findByKey(item.PredecessorKey);
                            if (predTask) {
                                item.ProjectOrder = predTask.ProjectOrder;
                                item.TaskID = predTask.TaskID;
                                item.TaskName = predTask.TaskName;
                            }
                            selectedPredecessors = selectedPredecessors + item.ProjectOrder;
                        }

                        if (u.obn(item.Lag) !== 0) {
                            selectedPredecessors = selectedPredecessors + ' (' + item.Lag + ')';
                        }
                    }
                }

                // var taskPredecessors = task.predecessors;
                // var item;
                // var predTask;
                // if (taskPredecessors) {
                //     for (var i = 0; i < taskPredecessors.length; i++) {
                //         item = taskPredecessors[i];
                //
                //         if (selectedPredecessors) selectedPredecessors += ', ';
                //
                //         if (item.CrossProject === 1) {
                //             selectedPredecessors = selectedPredecessors + u.obs(item.ProjectNumber).replace(',', '_') + ': ' + item.ProjectOrder;
                //         } else {
                //             predTask = ds.scheduleTasks.findByKey(item.PredecessorKey);
                //             if(predTask){
                //                 item.ProjectOrder = predTask.ProjectOrder;
                //                 item.TaskID = predTask.TaskID;
                //                 item.TaskName = predTask.TaskName;
                //             }
                //             selectedPredecessors = selectedPredecessors + item.ProjectOrder;
                //         }
                //
                //         if (u.obn(taskPredecessors[i].Lag) !== 0) {
                //             selectedPredecessors = selectedPredecessors + ' (' + taskPredecessors[i].Lag + ')';
                //         }
                //     }
                // }

                task.AssignedPreds = selectedPredecessors;

                if(task === ds.scheduleTasks.si) {
                    setScheduleTaskEnabled();
                }
            }
        }

        function setScheduleTaskEnabled(task) {

            task = task || ds.scheduleTasks.si;
            if(!task) return;

            dp.scheduleTaskEditable = Schedule.scheduleTaskEnabled(scheduleParms, task);

            if (u.obn(task.ConstraintDayOfTheWeek) > 0) {
                view.grids.grdPreds.columns = 'lag,task,inWks';
            } else {
                view.grids.grdPreds.columns = 'lag,task';
            }
        }

        function setupRollupData(tasks) {
            ds.summaryTasks.source = tasks;
            ds.summaryTasks.sortOn('ProjectOrder:dni');
            ds.summaryTasks.setFilter(filterSummaryTasks, true);

            ds.originalTasks.source = tasks;

            if (ds.summaryTasks.length > 0) {
                for (var i = 0; i < ds.summaryTasks.length; i++) {
                    var currentSummaryTask = ds.summaryTasks[i];
                    ds.originalTasks.setFilter("item.SummaryTaskKey==" + currentSummaryTask.TaskKey, true);

                    var currentEstHrs = 0;
                    var currentActHrs = 0;

                    for (var j = 0; j < ds.originalTasks.length; j++) {
                        if (ds.originalTasks[j].TaskType === 2) { // detail tasks - these sum first - these roll up to EstHours & ActualHours down below
                            //First need to add in the Change Order hours
                            ds.originalTasks[j].EstHours += u.obn(ds.originalTasks[j].ApprovedCOHours);
                            // assign from TotalEstHours & TotalActualHours if it's there, if not, use EstHours & ActualHours
                            currentEstHrs = currentEstHrs + u.obn(u.obn(ds.originalTasks[j].TotalEstHours, ds.originalTasks[j].EstHours));
                            currentActHrs = currentActHrs + u.obn(u.obn(ds.originalTasks[j].TotalActualHours, ds.originalTasks[j].ActualHours));
                        } else { // summary tasks - already rolled up to from EstHours and ActualHours so assign from those (not TotalEstHours & TotalActualHours)
                            currentEstHrs = currentEstHrs + u.obn(ds.originalTasks[j].EstHours);
                            currentActHrs = currentActHrs + u.obn(ds.originalTasks[j].ActualHours);
                        }
                    }

                    currentSummaryTask.EstHours = currentEstHrs;
                    currentSummaryTask.ActualHours = currentActHrs;
                }

                // add in detail only tasks approved change orders
                ds.originalTasks.setFilter(filtetDetailTasksNoSummary, true);
                if (ds.originalTasks.length > 0) {
                    for (var k = 0; k < ds.originalTasks.length; k++) {
                        var DetaillOnlyTask = ds.originalTasks[k];
                        ds.originalTasks[k].EstHours += u.obn(ds.originalTasks[k].ApprovedCOHours);
                    }
                }


                ds.summaryTasks.setFilter('');
                ds.originalTasks.setFilter('');


            } else {
                // Still have to add in the Change Order hours, even if there are no summary tasks
                for (var i = 0; i < tasks.length; i++) {
                    tasks[i].EstHours += u.obn(tasks[i].ApprovedCOHours);
                }
            }
            return tasks;
        }

        function filterSummaryTasks(item, idx, source) {
            if (item.TaskType === 1 && item.TrackBudget === 0)
                return true;
            else
                return false;
        }

        function filtetDetailTasksNoSummary(item, idx, source) {
            if (item.TaskType === 2 && u.obn(item.SummaryTaskKey) === 0)
                return true;
            else
                return false;
        }

        function finalizeProjectSchedule() {
            for (var i = 0; i < ds.scheduleTasks.source.length; i++) {
                var item = ds.scheduleTasks.source[i];
                item.BaseStart = item.PlanStart;
                item.BaseComplete = item.PlanComplete;
            }

            ds.scheduleTasks.refresh(true);
        }

        function initTaskSettings() {

            if ((ds.scheduleTasks.source.length === 0) || (u.obn(ds.scheduleTasks.si.SummaryTaskKey) == 0 && ds.scheduleTasks.si.TaskType == 2)) {
                ds.scheduleConstraints.source = arrScheduleConstraints2;
            } else {
                ds.scheduleConstraints.source = arrScheduleConstraints;
            }

        }

        //#region Printing Functions   ***************************************************************************
        function isParentCollapsed(taskKey) {
            if (taskKey === 0) {
                return false;
            }

            if (view.grids.grdProjectSchedule.nodes[taskKey]) {
                return true;
            }

            return isParentCollapsed(u.obn(ds.scheduleTasks.findByKey(taskKey, "TaskKey").SummaryTaskKey, 0));
        }

        function validateEndDate(start, end, zoomLevel) {

            var valid = true;
            var maxEndDate;
            var availColumns = 255;

            if (start && end) {
                switch (zoomLevel) {
                    case 'DAY':
                    case 'WEEK':
                        if (Date.diff(start, end, Date.DAY) + 10 > availColumns) {
                            valid = false;
                            maxEndDate = Date.add(start, availColumns - 10, Date.DAY);
                        }
                        break;
                    case 'MONTH':
                        if ((Date.diff(start, end, Date.MONTH) * 4) + 10 > availColumns) {
                            valid = false;
                            maxEndDate = Date.add(start, Math.floor(availColumns / 4) - 10, Date.MONTH);
                        }
                        break;
                }
            }
            return { valid: valid, max: maxEndDate };
        }

        function setPrintOptionView() {
            var opt = u.obn(ds.printSettings.si.PrintOption, 1);

            switch (opt) {
                case 1:
                    dp.showPrintScheduleOptions = true;
                    dp.showPrintScheduleGridOptions = false;
                    dp.showPrintClientScheduleOptions = false;
                    dp.showPrintGanttOptions = false;
                    break;
                case 5:
                    dp.showPrintScheduleOptions = false;
                    dp.showPrintScheduleGridOptions = true;
                    dp.showPrintClientScheduleOptions = false;
                    dp.showPrintGanttOptions = false;
                    break;
                case 4:
                    dp.showPrintScheduleOptions = false;
                    dp.showPrintScheduleGridOptions = false;
                    dp.showPrintClientScheduleOptions = true;
                    dp.showInitialsOnly = (ds.printSettings.si.includeAssignedUsers === 1);
                    dp.showPrintGanttOptions = false;
                    break;
                case 6:
                    dp.showPrintScheduleOptions = false;
                    dp.showPrintScheduleGridOptions = false;
                    dp.showPrintClientScheduleOptions = false;
                    dp.showPrintGanttOptions = true;
                    break;
                default:
                    dp.showPrintScheduleOptions = false;
                    dp.showPrintScheduleGridOptions = false;
                    dp.showPrintClientScheduleOptions = false;
                    dp.showPrintGanttOptions = false;
                    break;
            }
        }


        function convertTasksForPrinting() {
            var arr = [];
            var tsk;
            for (var i = 0; i < ds.scheduleTasks.source.length; i++) {
                tsk = ds.scheduleTasks.source[i];
                if (u.obn(tsk.HideFromClient) === 0) {
                    arr.push({
                        TaskKey: u.obn(tsk.TaskKey),
                        TaskName: u.obs(tsk.TaskName),
                        Description: u.obs(tsk.Description),
                        PlanStart: tsk.PlanStart,
                        PlanComplete: tsk.PlanComplete,
                        ProjectOrder: u.obn(tsk.ProjectOrder),
                        DueBy: u.obs(tsk.DueBy),
                        TaskType: u.obn(tsk.TaskType)
                    });
                }
            }
            return arr;
        }


        function getQuarter(month) {
            switch (month) {
                case 1:
                case 2:
                case 3:
                    return 'Q1';
                case 4:
                case 5:
                case 6:
                    return 'Q2';
                case 7:
                case 8:
                case 9:
                    return 'Q3';
                case 10:
                case 11:
                case 12:
                    return 'Q4';
                default:
                    return 'Q1';
            }
        }

        function buildMajorMinorScale() {

            var d = new Date(Date.parse(rangeStartDateLast));
            var s = d.toISOString();
            var y, m, dim, diy, first, style;

            minorScale = [];
            majorScale = [];

            switch (zoomLevel.toLowerCase()) {
                case 'year':
                    first = true;

                    var majorStartPosition;
                    var majorEndPosition;
                    var minorStartPosition;
                    var minorEndPosition;
                    var majorStartTime;
                    var currentQuarter;

                    while (s <= rangeEndDateLast) {
                        s = d.toISOString();
                        if (first || currentQuarter !== getQuarter(d.getMonth() + 1) + ' ' + d.getFullYear()) {
                            //first can be partial year
                            y = d.years;
                            m = d.months;

                            majorStartTime = floorToMonth(d, 3);
                            currentQuarter = getQuarter(majorStartTime.getMonth() + 1) + ' ' + majorStartTime.getFullYear();

                            majorStartPosition = transformTimeToPixels(majorStartTime, 2);

                            var majorScaleDate = {};
                            majorScaleDate.startDate = majorStartTime.toISOString();
                            var newDate = new Date();
                            newDate = majorStartTime.clone();
                            newDate.setMonth(newDate.getMonth() + 3);
                            majorScaleDate.endDate = newDate.toISOString();
                            majorScaleDate.text = currentQuarter;
                            majorScaleDate.startPosn = majorStartPosition;
                            majorScaleDate.endPosn = transformTimeToPixels(newDate, 2);
                            majorScale.push(majorScaleDate);
                        }

                        m = d.months;
                        dim = Date.getDaysInMonth(d.years, d.months + 1) - (m === undefined ? d.days - 1 : 0);

                        var minorScaleDate = {};

                        var minorStartTime = floorToMonth(d, 1);

                        minorScaleDate.startDate = minorStartTime;

                        minorStartPosition = transformTimeToPixels(minorStartTime, 2);

                        d.months += 1;

                        var minorEndTime = floorToMonth(d, 1);

                        minorEndPosition = transformTimeToPixels(minorEndTime, 2);

                        s = d.toISOString();
                        minorScaleDate.endDate = minorEndTime;
                        minorScaleDate.text = Date.getMonthName(minorStartTime.getMonth()).toString().substring(0, 3);
                        minorScaleDate.startPosn = minorStartPosition;
                        minorScaleDate.endPosn = minorEndPosition;
                        minorScale.push(minorScaleDate);
                        first = false;

                        minorStartPosition = minorEndPosition;

                    }
                    break;
                case 'month':
                    first = true;

                    var majorStartPosition;
                    var majorEndPosition;
                    var minorStartPosition;
                    var minorEndPosition;

                    while (s <= rangeEndDateLast) {
                        s = d.toISOString();

                        var majorStartTime;

                        if (first == true || m !== d.months) {

                            majorStartTime = floorToMonth(d, 1);

                            majorStartPosition = transformTimeToPixels(majorStartTime, 1);

                            m = d.months;
                            var majorScaleDate = {};
                            majorScaleDate.startDate = majorStartTime.toISOString();
                            var newDate = new Date();
                            newDate = majorStartTime.clone();
                            newDate.setMonth(newDate.getMonth() + 1);
                            majorScaleDate.endDate = newDate.toISOString();
                            majorScaleDate.text = Date.getMonthName(majorStartTime.getMonth()).toString() + ' ' + majorStartTime.getFullYear();
                            majorScaleDate.startPosn = majorStartPosition;
                            majorScaleDate.endPosn = transformTimeToPixels(newDate, 1);
                            majorScale.push(majorScaleDate);
                        }

                        var minorScaleDate = {};

                        var minorStartTime = floorToWeek(d, 1);

                        minorScaleDate.startDate = minorStartTime;

                        minorStartPosition = transformTimeToPixels(minorStartTime, 1);

                        d.days += 7;
                        var minorEndTime = floorToWeek(d, 1);

                        minorEndPosition = transformTimeToPixels(minorEndTime, 1);

                        s = d.toISOString();
                        minorScaleDate.endDate = minorEndTime;
                        minorScaleDate.text = minorStartTime.getDate();
                        minorScaleDate.startPosn = minorStartPosition;
                        minorScaleDate.endPosn = minorEndPosition;
                        minorScale.push(minorScaleDate);
                        first = false;

                        minorStartPosition = minorEndPosition;
                    }
                    break;
                case 'week':

                    first = true;

                    var dayNames = ['S', 'M', 'T', 'W', 'T', 'F', 'S'];

                    var majorStartPosition;
                    var majorEndPosition;
                    var minorStartPosition;
                    var minorEndPosition;

                    //days are always aligned so only need to align to week which we do by default.......
                    while (s <= rangeEndDateLast) {
                        s = d.toISOString();

                        diy = Date.isLeapYear(d.years) ? 366 : 365;

                        if (first) diy -= Date.getDayInYear(d.days, d.months + 1, d.years);

                        var dayOfWeek = Date.getDayOfWeek(d.getDate(), d.getMonth() + 1, d.getFullYear());

                        var startTime;
                        if (first) {
                            startTime = floorToWeek(d, 1);
                        } else {
                            startTime = d;
                        }

                        majorStartPosition = transformTimeToPixels(startTime, 0);

                        if (first) {
                            minorStartPosition = 0;
                        }

                        if (first == true || dayOfWeek == 1) {
                            var majorScaleDate = {};
                            majorScaleDate.startDate = startTime.toISOString();
                            majorScaleDate.endDate = Date.add(startTime.toISOString(), 7, Date.DAY);
                            majorScaleDate.text = Date.getMonthName(startTime.getMonth()).toString().substring(0, 3) + ' ' + startTime.getDate() + ', ' + startTime.getFullYear().toString().substring(2, 4);
                            majorScaleDate.startPosn = majorStartPosition;
                            majorScaleDate.endPosn = transformTimeToPixels(Date.fromISOString(Date.add(startTime.toISOString(), 7, Date.DAY)), 0);;
                            majorScale.push(majorScaleDate);
                        }

                        var minorScaleDate = {};
                        minorScaleDate.startDate = s;

                        d.days += 1;

                        minorEndPosition = transformTimeToPixels(d, 0);

                        s = d.toISOString();
                        minorScaleDate.endDate = s;
                        minorScaleDate.text = dayNames[dayOfWeek];
                        minorScaleDate.startPosn = minorStartPosition;
                        minorScaleDate.endPosn = minorEndPosition;
                        minorScale.push(minorScaleDate);
                        first = false;

                        minorStartPosition = minorEndPosition;
                    }

                    break;
                default:
                    break;
            }
        }

        /** Date Functions */
        function getRelativeDayOfWeek(value) {
            return (7 + Date.getDayOfWeek(value.getDate(), value.getMonth() + 1, value.getFullYear()) - 1) % 7;
        }

        function getLastDayOfWeek(value, updateValue) {
            return Date.add(value.toISOString(), 6 - getRelativeDayOfWeek(value), Date.DAY)
        }

        function getWeek(value) {
            var week = Date.fromISOString(getLastDayOfWeek(value))
            var year = week.getFullYear();
            if (week.getMonth() == 0) {
            }
            if (week.getDate() < minimalDaysInFirstWeek) {
                year = year - 1;
            }
            var d = getLastDayOfWeek(new Date(year, 0, minimalDaysInFirstWeek), true);
            return 1 + Math.round((week.getTime() - Date.fromISOString(d).getTime()) / (1000 * 60 * 60 * 24 * 7)); // TimeUnit.WEEK.milliseconds
        }

        function floorToWeek(value, interval) {
            var week = getWeek(value);
            var w = week - (week - 1) % interval;
            if (w < 1) {
                w = 1;
            }
            var offset = 7 * (week - w) + getRelativeDayOfWeek(value);
            return new Date(value.getFullYear(), value.getMonth(), value.getDate() - offset);
        }

        function floorToYear(value, interval) {
            return new Date(value.getFullYear() - value.getFullYear() % interval, 0, 1);
        }

        function floorToMonth(value, interval) {
            return new Date(value.getFullYear(), value.getMonth() - value.getMonth() % interval, 1);
        }

        function floorToDay(value, interval) {
            return new Date(Date.fromISOString(value).getFullYear(), Date.fromISOString(value).getMonth(), Date.fromISOString(value).getDate() - (Date.fromISOString(value).getDate() - 1) % interval);
        }

        function transformTimeToPixels(value, zoomLevel) {
            //this is the same as (date.time - minVisibleTime.time)/((maxVisibleTime.time-minVisibleTime.time)/width);
            //which means zoom is the same as ((maxVisibleTime.time-minVisibleTime.time)/width) 
            //i.e. milliseconds per pixel
            //remember that in a Gantt chart the time scale is a linear numeric scale not a category scale, 
            //there are therefore no "missing" dates or periods 
            //return (value.time - startTime.time) / zoom;

            return (value.getTime() - Date.fromISOString(rangeStartDateLast).getTime()) / arrZoomLevel[zoomLevel].zoom;
        }
        //#endregion Printing functions   ***************************************************************************

        function actionTopicHandler(topic, e) {

            var resp;
            var selectedTasks;

            console.log(e.action);

            switch (topic) {
                case 'mainMoreMenu':
                    switch (e.action) {
                        case 'toggleExpand':
                            gridExpanded = !gridExpanded;
                            if (gridExpanded) {
                                view.grids.grdProjectSchedule.expandAll();
                            } else {
                                view.grids.grdProjectSchedule.collapseAll();
                            }
                            break;
                        case 'openSettings':
                            Views.openPage(new Action('common.settings', dp.settingID, {}), e);
                            break;
                        case 'scheduleLock':
                        case 'unlockSchedule':
                            var locking = (e.action === 'scheduleLock');
                            Notify.showBusy(locking ? '|24980|Locking Schedule|' : '|24981|Unlocking Schedule|');
                            self.remoteDataCall('updateProjectScheduleLockStatus', { projectKey: ds.project.source.ProjectKey, projectName: ds.project.source.ProjectName, setLocked: locking }, function (results) {
                                if (results.errors) {
                                    Notify.error(ValidationManager.getMessage(results.errors, 'scheduleTasks'));
                                } else {
                                    Notify.success(locking ? '|24982|Schedule Locked|' : '|24983|Schedule Unlocked|');
                                    ds.project.source.ScheduleLockedByKey = results.data.scheduleLockedByKey;
                                    ds.project.fire();
                                }
                            });
                            break;
                        case 'finalizeSchedule':
                            Notify.showBusy('|24984|Finalizing Schedule|');
                            self.remoteDataCall('updateProjectScheduleFinalize', { tasks: ds.scheduleTasks.source }, function (results) {
                                if (results.errors) {
                                    Notify.error(ValidationManager.getMessage(results.errors, 'scheduleTasks'));
                                } else {
                                    Notify.success('|24985|Original schedule is finalized|');

                                    finalizeProjectSchedule();
                                }
                            });
                            break;
                        case 'projectSendNotifications':
                            Notify.confirm('|24986|Do you want to send an email notification to everyone assigned on the schedule?|', false).done(function (val) {
                                sendingProjectNotifications = true;

                                if(ds.scheduleTasks.isDirty()){
                                    //if the schedule is dirty, save it first.
                                    //passing in true to getModifiedItems triggers the save event
                                    ds.scheduleTasks.getModifiedItems(true);
                                    return;
                                }
                                sendProjectNotifications();
                            });

                            break;
                        case 'copyProjectTasks':
                            Views.openPanel(view, 'projectToCopy');
                            break;
                        case 'reassignAll':
                            actionTopicHandler(null, {action: 'reassignAll'});
                            break;
                    }
                    break;
                case 'pnlEditAssignments':
                    switch (e.action) {
                        case 'frmScheduleReassign.save':
                            //This processes the reassign logic
                            var reassignSelectedTasks = dp.showAssignAllTasks ? ds.reassignTasks.getTaggedRows('TaskKey') : ds.reassignTasks.source;
                            if (!Schedule.reassignCheck(scheduleParms, reassignSelectedTasks)) {
                                Notify.confirm('|26973|Some assignments are complete and will not be modified. Do you want to continue?|', false).done(function (val) {
                                    reassign(reassignSelectedTasks);
                                });
                                return;
                            }
                            reassign(dp.showAssignAllTasks ? reassignSelectedTasks : null);
                            break;
                        case 'frmAddAssignmentToSelectedTasks.save':
                            var itemAdded = false;
                            var tempItem = ds.addAssignmentToSelectedTasks.si;
                            if (u.obn(tempItem.TaskKey) === 0) {
                                Notify.error('|26272|Please enter a task|');
                                return;
                            }

                            var taskItem = ds.scheduleTasks.findByKey(tempItem.TaskKey);
                            if(!taskItem) return;

                            if(taskItem.ScheduleTask !== 1){
                                Notify.error('|0|You must select a schedule task|');
                                return;
                            }

                            if (tempItem.UserKey > 0) {
                                var addUserKey = tempItem.UserKey;
                                var newItem = ds.taskUsers.addItem(
                                    {
                                        TaskUserKey: ds.taskUsers.getNextKey(),
                                        TaskKey: tempItem.TaskKey,
                                        UserKey: addUserKey,
                                        UserName: tempItem.UserName,
                                        Initials: tempItem.Initials,
                                        ServiceKey: tempItem.ServiceKey > 0 ? tempItem.ServiceKey : tempItem.DefaultServiceKey,
                                        ServiceCode: tempItem.ServiceKey > 0 ? tempItem.ServiceCode : tempItem.DefaultServiceCode,
                                        ServiceDescription: tempItem.ServiceKey > 0 ? tempItem.ServiceDescription : tempItem.DefaultServiceDescription,
                                        ProjectKey: ds.project.si.ProjectKey,
                                        Hours: tempItem.Hours
                                    }
                                );
                                itemAdded = true;
                            } else if (tempItem.ServiceKey > 0) {
                                var newItem = ds.taskUsers.addItem(
                                    {
                                        TaskUserKey: ds.taskUsers.getNextKey(),
                                        TaskKey: tempItem.TaskKey,
                                        ServiceKey: tempItem.ServiceKey,
                                        ServiceCode: tempItem.ServiceCode,
                                        ServiceDescription: tempItem.ServiceDescription,
                                        ProjectKey: ds.project.si.ProjectKey,
                                        Hours: tempItem.Hours
                                    }
                                );
                                itemAdded = true;
                            } else {
                                Notify.error('|26273|Either a service or a user is required|');
                            }

                            if (itemAdded) {
                                ds.taskUsers.itemUpdated('I', newItem, false);

                                //This will rollup the user's initials to the Assigned field
                                Schedule.rollupActuals(scheduleParms, newItem);
                                dp.showAssignmentDropBox = false;

                                var taggedRows = ds.scheduleTasks.getTaggedRows();
                                var taskAlreadyTagged = false;
                                for (var i = 0; i < taggedRows.length; i++) {
                                    if(taggedRows[i].TaskKey === newItem.TaskKey){
                                        taskAlreadyTagged = true;
                                        break;
                                    }
                                }
                                if(!taskAlreadyTagged){
                                    var findItem = ds.scheduleTasks.findByKey(newItem.TaskKey);
                                    if(findItem){
                                        taggedRows = taggedRows.concat(findItem);
                                    }
                                }

                                ds.reassignTasks.source = Schedule.getSelectedTaskAssignmentsWithParents(scheduleParms, taggedRows);
                                ds.addAssignmentToSelectedTasks.source = {ProjectKey: key};
                            }
                            break;
                    }
                case 'pnlAssignments':
                    switch (e.action) {
                        case 'pnlAssignments.init':
                            if (dp.projectScheduleEditable) {
                                view.grids.grdAssignments.editmode = 'int|ins|del';
                                view.grids.grdAssignments.selectable = false;
                            }else{
                                view.grids.grdAssignments.editmode = '';
                                view.grids.grdAssignments.selectable = false;
                            }

                            view.grids.grdAssignments.locked = 1;
                            if(dp.showBuckets) {
                                var el = e.target.getElementsByClassName('show-weeks');
                                if (el.length > 0) {
                                    Buttons.toggle(el[0], undefined, true);
                                }
                                calcColumns(true);
                            }
                            break;
                        case 'showBuckets':
                            dp.showBuckets = !dp.showBuckets;
                            store.scheduleShowBuckets = dp.showBuckets;
                            ds.setStorage(store);

                            calcColumns(true);
                            break;
                        case 'movePrevious':
                            ds.scheduleTasks.prev();
                            while ((ds.scheduleTasks.si.TaskType === 1 || ds.scheduleTasks.si.ScheduleTask === 0) && ds.scheduleTasks.selectedIndex > 0) {
                                ds.scheduleTasks.prev();
                            }
                            while ((ds.scheduleTasks.si.TaskType === 1 || ds.scheduleTasks.si.ScheduleTask === 0) && ds.scheduleTasks.selectedIndex < ds.scheduleTasks.source.length - 1) {
                                ds.scheduleTasks.next();
                            }
                            dp.showAssignmentDropBox = !ds.scheduleTasks.si.Assigned;
                            calcColumns(true);
                            break;
                        case 'moveNext':
                            ds.scheduleTasks.next();
                            while ((ds.scheduleTasks.si.TaskType === 1 || ds.scheduleTasks.si.ScheduleTask === 0) && ds.scheduleTasks.selectedIndex < ds.scheduleTasks.source.length - 1) {
                                ds.scheduleTasks.next();
                            }
                            while ((ds.scheduleTasks.si.TaskType === 1 || ds.scheduleTasks.si.ScheduleTask === 0) && ds.scheduleTasks.selectedIndex > 0) {
                                ds.scheduleTasks.prev();
                            }
                            dp.showAssignmentDropBox = !ds.scheduleTasks.si.Assigned;
                            calcColumns(true);
                            break;
                        case "changeSource":
                            dp.assignmentTab = e.target.value;
                            switch (e.target.value) {
                                case 'service':
                                    dp.showDetails = false;
                                    filterUserServices();
                                    break;
                                case 'people':
                                    dp.showDetails = false;
                                    ds.toAssignList.source = users;
                                    break;
                                case 'task':
                                    dp.showDetails = true;
                                    break;
                            }
                            break;
                        case 'lstToAssign.dragstart':
                            if (dp.showAssignmentDropBox) {
                                e.detail.dropzones = '#divAssignmentDrop';
                                //for a container tagName what tagName we drop on (OL:LI, TABLE:TR)
                                e.detail.dropItemTypes['DIV'] = 'DIV';
                            } else {
                                e.detail.dropzones = '#grdAssignments';
                            }
                            break;
                        case 'lstToAssign.drop':
                            e.detail.performed = "none"; //keeps the user/service in the list
                            //no break!!! continue on below...
                        case 'addUser':
                            var addUserKey = (e.action === 'addUser') ? e.actionKey : e.dragKey;
                            var assignItem = ds.toAssignList.findByKey(addUserKey);
                            if (assignItem) {
                                var newItem = ds.taskUsers.addItem(
                                    {
                                        TaskUserKey: ds.taskUsers.getNextKey(),
                                        TaskKey: ds.scheduleTasks.si.TaskKey,
                                        UserKey: addUserKey > 0 ? addUserKey : null,
                                        UserName: addUserKey > 0 ? assignItem.Label : null,
                                        Initials: addUserKey > 0 ? assignItem.Initials : null,
                                        ServiceKey: addUserKey > 0 ? assignItem.DefaultServiceKey : (addUserKey * -1),
                                        ServiceCode: assignItem.ServiceCode,
                                        ServiceDescription: addUserKey > 0 ? assignItem.ServiceDescription : assignItem.Label,
                                        ProjectKey: ds.project.si.ProjectKey
                                    }
                                );

                                if (dp.isRetainer) {
                                    newItem.ManualAdjustment = 1;

                                    if (ds.scheduleTasks.si.tuhTaskParms) {
                                        var buckets = ds.scheduleTasks.si.tuhTaskParms.buckets;
                                        for (var b = 0; b < buckets.length; b++) {
                                            if (buckets[b].prevWeek) {
                                                newItem['Offset_' + b] = 0;
                                            }
                                        }
                                    }
                                }

                                ds.taskUsers.itemUpdated('I', newItem, false);

                                if(dp.isRetainer && addUserKey > 0 && u.obn(assignItem.DefaultServiceKey) == 0){
                                    dp.assignmentTab = 'service';
                                    filterUserServices();
                                    Notify.alert('No default service has been selected for this user.');
                                }

                                //This will rollup the user's initials to the Assigned field
                                Schedule.rollupActuals(scheduleParms, newItem);
                                dp.showAssignmentDropBox = false;
                            }
                            break;
                    }
                    break;
                case 'pnlAddAssignments':
                    switch (e.action) {
                        case 'assignSelected':
                            var selUsers = ds.toAssignList.getTaggedRows();
                            var selTasks = ds.scheduleTasks.getTaggedRows();

                            if (selUsers.length === 0) {
                                Notify.alert(System.localize("|24989|No users or services have been selected|"));
                                return;
                            }

                            var taskItem;
                            var assignItem;
                            var userKey;
                            var newItem;
                            for (var t = 0; t < selTasks.length; t++) {
                                taskItem = selTasks[t];
                                if (taskItem.TaskType === 2 && taskItem.ScheduleTask === 1) {
                                    for (var userCount = 0; userCount < selUsers.length; userCount++) {
                                        assignItem = selUsers[userCount];
                                        userKey = assignItem.UserKey;

                                        newItem = ds.taskUsers.addItem(
                                            {
                                                TaskUserKey: ds.taskUsers.getNextKey(),
                                                TaskKey: taskItem.TaskKey,
                                                UserKey: userKey > 0 ? userKey : null,
                                                UserName: userKey > 0 ? assignItem.Label : null,
                                                Initials: userKey > 0 ? assignItem.Initials : null,
                                                ServiceKey: userKey > 0 ? assignItem.DefaultServiceKey : (userKey * -1),
                                                ServiceCode: assignItem.ServiceCode,
                                                ServiceDescription: userKey > 0 ? assignItem.ServiceDescription : assignItem.Label,
                                                ProjectKey: ds.project.si.ProjectKey,
                                                Hours: assignItem.Hours
                                            }
                                        );
                                        ds.taskUsers.itemUpdated('I', newItem, false);
                                    }
                                    //we only have to do the rollup once for each task.
                                    //we can pass in the last newItem added because it just needs it to get the taskKey
                                    if (newItem) Schedule.rollupActuals(scheduleParms, newItem);
                                }
                            }

                            ds.toAssignList.commitTaggedItems(selUsers, null, null, 'untag');
                            ds.scheduleTasks.commitTaggedItems(selTasks, null, null, 'untag');

                            //no break, continue on to clear out the hours and close the panel
                        case 'cancelAddAssignments':
                            for (var i = 0; i < users.length; i++) {
                                users[i].Hours = null;
                            }
                            for (var i = 0; i < services.length; i++) {
                                services[i].Hours = null;
                            }

                            Views.close(view.panels.pnlAddAssignments);
                            break;
                        case 'changeAddAssignmentsSource':
                            dp.addAssignmentTab = e.target.value;
                            switch (e.target.value) {
                                case 'service':
                                    ds.toAssignList.source = services;
                                    dp.showAddServiceAssignments = true;
                                    break;
                                case 'people':
                                    ds.toAssignList.source = users;
                                    dp.showAddServiceAssignments = false;
                                    break;
                            }
                            break;
                    }
                    break;
                case "printOptions":
                    switch (e.action) {
                        case "printSched":
                            var projectData = ds.project.si;
                            var rptClass = '';
                            var taskPrintKey = 0;
                            var parms = ds.printSettings.si;
                            parms.ProjectKey = key;

                            switch (u.obn(parms.PrintOption, 1)) {
                                case 1: //Print Schedule
                                    rptClass = 'WJ.Reports.StandardReports.TasksSetup.run';
                                    parms.ShowAssignments = 1;
                                    parms.ShowAssignedHours = 1;
                                    break;
                                case 2: //Task Assignments
                                    var selectedData = ds.scheduleTasks.getTaggedRows()
                                    if (selectedData.length === 0) {
                                        Notify.alert('|24990|You must select a Task prior to printing a Task Assignment.|', 'error');
                                        return;
                                    }
                                    taskPrintKey = u.obn(selectedData[0].TaskKey);
                                case 3: //All Task Assignments
                                    rptClass = 'WJ.Reports.StandardReports.TaskAssignmentSheet.run';
                                    parms.PrintedBy = System.user.userKey;
                                    parms.TaskKey = taskPrintKey;
                                    break;
                                case 4: //Client Schedule
                                    rptClass = 'WJ.Reports.StandardReports.ProjectClientSchedule.run';
                                    parms.projectKey = key; //projectKey is camel case for this report

                                    parms.clientFullName = u.obs(projectData.ClientID) + '-' + u.obs(projectData.ClientName);
                                    parms.projectFullName = u.obs(projectData.ProjectNumber) + '-' + u.obs(projectData.ProjectName);
                                    parms.teamKey = u.obn(projectData.TeamKey);
                                    parms.tasks = convertTasksForPrinting();
                                    parms.assignedUsers = ds.taskUsers.source;
                                    break;
                                case 5: // Print Grid
                                    view.grids.grdProjectSchedule.printGrid(e, "Project Schedule", u.obs(projectData.ProjectNumber) + '-' + u.obs(projectData.ProjectName), (parms.PrintToExcel === 1), "", true, "depth", "", "1", true, null, 0, false, "", u.obb(ds.printSettings.si.PreserveDateFormats));
                                    return;
                                case 6: //Print Gantt                                   

                                    // Check for max date allowed.
                                    if (ds.printSettings.si.ReportType === 4) {
                                        var maxEndDate = validateEndDate(ds.printSettings.si.StartDate, ds.printSettings.si.EndDate, ds.printSettings.si.ZoomLevelName.toUpperCase());
                                        if (maxEndDate.valid === false) {
                                            Notify.alert('|24991|This date range will exceed the total number of columns allowed in an Excel spreadsheet. The maximum end date is |' + Date.formatDate(maxEndDate.max, 'd'), 'error');
                                            return;
                                        }
                                    }

                                    switch (ds.printSettings.si.ZoomLevelName.toUpperCase()) {
                                        case 'DAY':
                                            zoomLevel = 'WEEK';
                                            break;
                                        case 'WEEK':
                                            zoomLevel = 'MONTH';
                                            break;
                                        case 'MONTH':
                                            zoomLevel = 'YEAR';
                                            break;
                                    }

                                    //ppd = view.grids.grdProjectSchedule.plugin.zoomLevel.ppd;
                                    var newTasks = [];
                                    var endDate = Date.add(u.obo(ds.scheduleTasks.source[ds.scheduleTasks.source.length - 1].PlanComplete, ds.printSettings.si.StartDate), 1, Date.MONTH);

                                    for (i = 0; i < ds.scheduleTasks.source.length; i++) {
                                        if (!isParentCollapsed(ds.scheduleTasks.source[i].SummaryTaskKey)) {
                                            if (Date.greater(ds.scheduleTasks.source[i].PlanComplete, endDate)) {
                                                endDate = ds.scheduleTasks.source[i].PlanComplete
                                            }
                                            var newTask = {};
                                            newTask.showSummaryTails = (ds.scheduleTasks.source[i].TaskType == 1) ? true : false;
                                            newTask.end = ds.scheduleTasks.source[i].PlanComplete;
                                            newTask.display = true;
                                            newTask.showPercentCompleteBar = (ds.scheduleTasks.source[i].TaskType == 1) ? false : true;
                                            newTask.start = ds.scheduleTasks.source[i].PlanStart;
                                            newTask.label = ds.scheduleTasks.source[i].TaskName;
                                            newTask.percComp = ds.scheduleTasks.source[i].PercComp;
                                            newTask.level = ds.scheduleTasks.source[i].TaskLevel;
                                            newTask.duration = ds.scheduleTasks.source[i].PlanDuration;
                                            newTask.id = '';
                                            newTask.barHeight = .13;

                                            if (ds.scheduleTasks.source[i].TaskColor) {
                                                newTask.color = ds.scheduleTasks.source[i].TaskColor;
                                            } else {
                                                switch (ds.scheduleTasks.source[i].TaskStatus) {
                                                    case 1:
                                                        newTask.color = 65280;
                                                        break;
                                                    case 2:
                                                        newTask.color = 16776960;
                                                        break;
                                                    case 3:
                                                        newTask.color = 16711680;
                                                        break;
                                                }

                                                if (ds.scheduleTasks.source[i].TaskType == 1) {
                                                    newTask.barHeight = .08;
                                                    newTask.color = 6939;
                                                }
                                            }

                                            newTasks.push(newTask);
                                        }
                                    }

                                    if (ds.printSettings.si.DateRangeKey == 0) {
                                        ds.printSettings.si.StartDate = Date.add(ds.scheduleTasks.source[0].PlanStart, -1, Date.MONTH);
                                        ds.printSettings.si.EndDate = Date.add(endDate, 1, Date.MONTH);
                                    }

                                    rangeStartDateLast = ds.printSettings.si.StartDate;
                                    rangeEndDateLast = ds.printSettings.si.EndDate;

                                    buildMajorMinorScale();
                                    if (ds.printSettings.si.ReportType === 2) {
                                        rptClass = 'WJ.Reports.StandardReports.GANTT.run';
                                    } else {
                                        rptClass = 'WJ.Reports.StandardReports.GANTTExcelReport.run';
                                    }

                                    parms.exportType = ds.printSettings.si.ReportType;
                                    parms.startDate = rangeStartDateLast;
                                    parms.endDate = rangeEndDateLast;
                                    parms.data = newTasks;
                                    parms.minorScale = minorScale;
                                    parms.majorScale = majorScale;
                                    parms.zoomLevel = ds.printSettings.si.ZoomLevelName.toUpperCase();
                                    parms.reportTitle = ds.project.si.ProjectNumber + ' - ' + ds.project.si.ProjectName;
                                    parms.indentWidth = indentWidth;
                                    break;
                            }

                            Notify.showBusy('Printing');
                            self.remoteDataCall(rptClass, parms, function (results) {
                                Notify.hideBusy();
                                u.printReport(results, 'Schedule', e);
                                Views.close(view.panels.printOptions);
                            });
                            break;
                        case "printOptions.init":
                            setPrintOptionView();
                            if (ds.scheduleTasks.source.length == 0) {
                                return;
                            }
                            if (!ds.printSettings.si.StartDate) {
                                ds.printSettings.si.DateRangeKey = 0;
                                ds.printSettings.si.DateRangeName = 'All';
                                ds.printSettings.si.ReportType = 2;


                                ds.printSettings.si.StartDate = Date.add(ds.scheduleTasks.source[0].PlanStart, -1, Date.MONTH);
                                ds.printSettings.si.EndDate = Date.add(ds.scheduleTasks.source[ds.scheduleTasks.source.length - 1].PlanComplete, 1, Date.MONTH);

                                for (i = 0; i < ds.scheduleTasks.source.length; i++) {
                                    if (!isParentCollapsed(ds.scheduleTasks.source[i].SummaryTaskKey)) {
                                        if (Date.greater(ds.scheduleTasks.source[i].PlanComplete, ds.printSettings.si.EndDate)) {
                                            ds.printSettings.si.EndDate = ds.scheduleTasks.source[i].PlanComplete
                                        }
                                    }
                                }
                            }

                            if (Views.displayMode == 'desktop') {
                                switch (view.grids.grdProjectSchedule.plugin.zoomLevel.id) {
                                    case 'week':
                                        ds.printSettings.si.ZoomLevelName = 'Day';
                                        ds.printSettings.si.ZoomLevelKey = 1;
                                        break;
                                    case 'month':
                                        ds.printSettings.si.ZoomLevelName = 'Week';
                                        ds.printSettings.si.ZoomLevelKey = 2;
                                        break;
                                    case 'year':
                                        ds.printSettings.si.ZoomLevelName = 'Month';
                                        ds.printSettings.si.ZoomLevelKey = 3;
                                        break;
                                }
                            } else {
                                ds.printSettings.si.ZoomLevelName = 'Day';
                                ds.printSettings.si.ZoomLevelKey = 1;
                            }
                            break;
                    }
                    break;
                case 'assignments':
                    if (e.action === 'openPanel') {
                        openAssignmentPanel(e.actionKey ? e.actionKey : ds.scheduleTasks.si.TaskKey);
                    }
                    break;
                default:
                	switch (e.action) {                		
                	    case "grdProjectSchedule.layoutChange":
                	        var obj = {};
                	        obj[widthSettings] = e.widths;
                	        System.saveSession(obj, dp.settingID);
                	        break;
                	    case "AddNewToDoInsertRow":
                			useGridAdd();
                			break;
                		case "AddNewToDoDetail":
                			insertToDoRow();
                			break;
                        case "grdToDos.dropcomplete":
                            //Drag item
                            var dragSource = e.dragSource
                            var dragItem = ds.todoItems.findByKey(e.dragKey);
                            var dragItemActivityStatusKey = dragItem.ActivityStatusKey;
                            var dragItemActivityKey = dragItem.ActivityKey;
                            var dragItemDisplayOrder = dragItem.DisplayOrder;
                            var dragItemStatusName = dragItem.StatusName;
                            var dragItemIsCompleted = u.obn(dragItem.IsComplete, 0); // This does not mean that the todo is complete. It means tActivityStatus.IsCompleted = 1

                            //Drop item
                            var dropSource = e.dropSource
                            var dropItem = ds.todoItems.findByKey(e.dropKey);
                            var dropItemActivityStatusKey = dropItem.ActivityStatusKey;
                            var dropItemActivityKey = dropItem.ActivityKey;
                            var dropItemDisplayOrder = dropItem.DisplayOrder;
                            var dropItemStatusName = dropItem.StatusName;
                            var dropItemIsCompleted;
                            dropItemIsCompleted = u.obn(dropItem.IsCompleted, 0); // This does not mean that the todo is complete. It means tActivityStatus.IsCompleted = 1

                            //DropLocation
                            var dropLocation = e.dropLocation

                            // Need to peel off the todos for the current task only. ds.todoItems.source contains the todos for all tasks
                            var todos = [];
                            for (var todoItemCounter = 0; todoItemCounter < ds.todoItems.length; todoItemCounter++) {
                                for (var childrenCounter = 0; childrenCounter < ds.todoItems[todoItemCounter].children.length; childrenCounter++) {
                                    todos.push(ds.todoItems[todoItemCounter].children[childrenCounter]);
                                }
                            }

                            var k = 1;
                            for (var i = 0; i < todos.length; i++) {
                                // Special handling for the actual item that was dragged
                                if (todos[i].ActivityKey === dragItemActivityKey) {
                                    todos[i].ActivityStatusKey = dropItemActivityStatusKey
                                    todos[i].DisplayOrder = k;
                                    // Dropped to a group which is designated as an 'IsCompleted' status
                                    if (u.obn(dropItemIsCompleted, 0) === 1) {
                                        todos[i].Completed = 1;
                                        todos[i].IsCompleted = 1;
                                    } else {
                                        todos[i].Completed = 0;
                                        todos[i].IsCompleted = 0;
                                    }
                                    k = k + 1;
                                }
                                // The remaining items in the drop group - update their DisplayOrder only
                                else if (todos[i].ActivityStatusKey === dropItemActivityStatusKey) {
                                    todos[i].DisplayOrder = k;
                                    k = k + 1;
                                }
                            }

                            // If the drag group and the drop group are different, now update the drag group DisplayOrder
                            if (dragItemActivityStatusKey !== dropItemActivityStatusKey) {
                                k = 1;
                                for (var i = 0; i < todos.length; i++) {
                                    if (todos[i].ActivityStatusKey === dragItemActivityStatusKey) {
                                        todos[i].DisplayOrder = k;
                                        k = k + 1;
                                    }
                                }
                            }

                            self.remoteDataCall('updateTodoDisplayOrders', { item: todos }).done(function (results) {
                                if (results.errors) {
                                    Notify.error(ValidationManager.getMessage(results.errors, 'Activity'));
                                } else {
                                    ds.todoItems.refresh(true);
                                }
                            });

                            break; // end grdToDos.dropComplete

                        case 'init':
                            if(dp.isRetainer){
                                if(dp.showBuckets) {
                                    var el = e.target.getElementsByClassName('show-weeks');
                                    if (el.length > 0) {
                                        Buttons.toggle(el[0], undefined, true);
                                    }
                                    calcColumns(true);
                                }
                            }else {
                                if (dp.projectScheduleEditable) {
                                    view.grids.grdProjectSchedule.editmode = Views.displayMode !== 'mobile' ? 'int|ins|del' : '';
                                    view.grids.grdProjectSchedule.selectable = true;
                                } else {
                                    view.grids.grdProjectSchedule.editmode = '';
                                    view.grids.grdProjectSchedule.selectable = false;
                                }
                            }
                            break;
                        case 'deleteSelected':
                            Notify.confirm('|24453|Are you sure that you want to delete the selected tasks?|', false).done(function (val) {
                                deleteTasks(ds.scheduleTasks.getTaggedRows());
                            });
                            break;
                        case 'completeSelected':
                            selectedTasks = ds.scheduleTasks.getTaggedRows(false, true);
                            if (selectedTasks.length === 0) {
                                Notify.error('|24992|You must select at least one task to complete|');
                                return;
                            }
                            completeTasks(selectedTasks);
                            ds.scheduleTasks.commitTaggedItems(selectedTasks, null, null, 'untag');
                            ds.scheduleTasks.refresh();
                            break;
                        case 'grdProjectSchedule.grid-plugin-size':
                            System.saveSession({ grdProjectScheduleGanttPanelSize: e.detail.size }, 'projectSchedule');
                            break;
                        case 'notifySelectedTaskUsers':
                            Notify.confirm('|24993|Do you want to send an email notification to assigned users of the selected tasks?|', false).done(function (val) {
                                var selectedTasks = ds.scheduleTasks.getTaggedRows();
                                if (selectedTasks.length === 0) {
                                    Notify.error('|24994|You must first select one or more tasks|');
                                    return;
                                }
                                var selectedKeys = '';
                                for (var i = 0; i < selectedTasks.length; i++) {
                                    if (selectedTasks[i].taskUsers) {
                                        if (selectedKeys.length === 0) {
                                            selectedKeys = selectedTasks[i].TaskKey;
                                        } else {
                                            selectedKeys += ',' + selectedTasks[i].TaskKey
                                        }
                                    }
                                }

                                notifySelectedTaskKeys = selectedKeys;

                                if(ds.scheduleTasks.isDirty()){
                                    //if the schedule is dirty, save it first.
                                    //passing in true to getModifiedItems triggers the save event
                                    ds.scheduleTasks.getModifiedItems(true);
                                    return;
                                }
                                sendSelectedNotifications();
                            });
                            break;
                        case "sideAction":
                            dp.sideAction = e.actionKey;
                            dp.showHideTheSidebar = (dp.sideAction !== 'none');
                            System.saveSession({ sideAction: dp.sideAction }, 'projectSchedule');
                            view.grids.grdProjectSchedule.showPlugin = dp.sideAction === 'showGantt';
                            setShowTemplateDropBox();

                            break;
                        case "lstConversations.conversationsEdit":
                            var entity = e.detail.Entity; //Meeting or Activity
                            var entityKey = e.detail.EntityKey; //should be same as e.actionKey
                            switch (entity) {
                                case "Activity":
                                    Views.openPage(new Action("cm.activities.edit", entityKey), e);
                                    break;
                                case "Meeting":
                                    Views.openPage(new Action("user.meeting", entityKey), e);
                                    break;
                            }
                            break;
                        case "addConversation":
                            Views.openPage(new Action("projects.diary.add", key, { taskKey: ds.scheduleTasks.si.TaskKey }), e);
                            break;
                        case "openTimeDetail":
                            var selectedTask = ds.scheduleTasks.findByKey(e.actionKey);
                            if (selectedTask) {
                                if (selectedTask.TrackBudget === 1) {
                                    Views.openPage(new Action('projects.production.timeDetail', selectedTask.ProjectKey, { ProjectKey: selectedTask.ProjectKey, TaskKey: e.actionKey, Entity: "Task" }), e);
                                }
                            }
                            break;
                        case "grdProjectSchedule.dragstart":
                            e.detail.location = 'before-on-after';
                            return dp.projectScheduleEditable;
                            break;
                        case 'grdProjectSchedule.drop':
                        case 'moveTaskIn':
                        case 'moveTaskOut':
                            if (!dp.projectScheduleEditable) return false;

                            var isDrop = (e.action === 'grdProjectSchedule.drop');

                            var moveTask = isDrop ? e.dragItem : e.actionKey ? ds.scheduleTasks.findByKey(e.actionKey) : ds.scheduleTasks.si;
                            if(!moveTask) return;

                            var referenceTask = isDrop ? e.dropItem : DataManager.getPrevSibling(ds.scheduleTasks, moveTask);
                            var dropAsChild = (isDrop && (e.dropLocation === 'on') || (e.action === 'moveTaskIn'));

                            //This will determine if the task is allowed to be moved to the location that is being attempted.
                            //The resp object will contain any errors that were generated. It will have a property "isAllowed" that is used below.
                            var resp = Schedule.isMoveTaskAllowed(scheduleParms, moveTask, referenceTask, dropAsChild);
                            processScheduleErrors(resp);

                            if (dropAsChild) {
                                //This will return false if the referenceTask has assignments, so that we can ask if it's OK to remove the assignments
                                if (!Schedule.isDropAsChildAllowed(scheduleParms, referenceTask)) {
                                    Notify.confirm(System.localize('|24620|Is it OK to delete the assigned users from the new parent task?|'), false).done(function (val) {
                                        //This will remove all users assigned to this task
                                        Schedule.removeTaskAssignedUsers(scheduleParms, referenceTask);
                                        moveTaskIn(moveTask, referenceTask);
                                    });
                                    return false; //return false from the drop event, and we'll do it manually after the user responds to the question above
                                }
                            }

                            if (isDrop) {
                                if (Key.ctrlKey) {
                                    duplicateTask(e.dragItem, e.dropItem, dropAsChild);
                                    return false; //stop the move action of the drag/drop because this is a copy instead
                                } else {
                                    //if it is a drop, then the moveTaskIn was already handled during the drop.
                                    return resp.isAllowed;
                                }
                            } else {
                                //if not, we need to move it here
                                if (e.action === 'moveTaskIn') {
                                    moveTaskIn(moveTask, referenceTask);
                                } else {
                                    moveTaskOut(moveTask);
                                }
                            }
                            break;
                        case 'grdProjectSchedule.dropcomplete':
                            if (!dp.projectScheduleEditable) return false;
                            //This will process the scheduling logic to handle the move to the new location in the schedule
                            processScheduleErrors(Schedule.afterMoveTask(scheduleParms, e.dragItem, e.oldParent));
                            break;
                        case "grdProjectTemplate.dragstart":
                            if (!dp.projectScheduleEditable) {
                                return;
                            }
                            e.detail.location = 'before-on-after';
                            if (dp.showTemplateDropBox) {
                                e.detail.dropzones = '#divTemplateDrop';
                                //for a container tagName what tagName we drop on (OL:LI, TABLE:TR)
                                e.detail.dropItemTypes['DIV'] = 'DIV';
                                //return "divTemplateDrop:div";
                            } else {
                                e.detail.dropzones = '#grdProjectSchedule';
                                ///return "grdProjectSchedule";
                            }
                            break;
                        case "grdProjectTemplate.drop":
                            e.detail.performed = "none";

                            if (!dp.projectScheduleEditable) return false;

                            if (e.dropLocation === 'on') {
                                //This will return false if the referenceTask has assignments, so that we can ask if it's OK to remove the assignments
                                if (e.dropItem && !Schedule.isDropAsChildAllowed(scheduleParms, e.dropItem)) {
                                    Notify.confirm(System.localize('|24620|Is it OK to delete the assigned users from the new parent task?|'), false).done(function (val) {
                                        //This will remove the users assigned to the task
                                        Schedule.removeTaskAssignedUsers(scheduleParms, e.dropItem);
                                        //This will add the template task (and all of its children) to the schedule
                                        Notify.showBusy('Copying template tasks');
                                        Schedule.dropTemplateTask(scheduleParms, e.dragItem, e.dropItem, true);
                                        setShowTemplateDropBox();
                                        Notify.hideBusy();
                                    });
                                    return false; //return false from the drop event, and we'll do it manually after the user responds to the question above
                                }
                            }

                            break;
                        case "grdProjectTemplate.dropcomplete":
                            //This will add the template task (and all of its children) to the schedule
                            Notify.showBusy('Copying template tasks');
                            Schedule.dropTemplateTask(scheduleParms, e.dragItem, e.dropItem, (e.dropLocation === 'on'), (e.dropLocation === 'after'));
                            setShowTemplateDropBox();
                            Notify.hideBusy();
                            break;
                        case 'duplicateTask':
                            duplicateTask(ds.scheduleTasks.si);
                            break;
                        case 'insertBelowTask':
                            insertBelowTask(ds.scheduleTasks.si);
                            break;
                        case 'linkToTaskAbove':
                            var item = e.actionKey ? ds.scheduleTasks.findByKey(e.actionKey) : ds.scheduleTasks.si;
                            var _idx = ds.scheduleTasks.getIndexOf(item);
                            if(_idx > 0 && _idx < ds.scheduleTasks.source.length){
                                var prev = ds.scheduleTasks.source[_idx - 1];
                                if (prev) {
                                    //This will set a predecessor
                                    resp = Schedule.linkToTask(scheduleParms, item, prev);
                                    processScheduleErrors(resp);
                                    updatePredKeys([item]);
                                }
                            }
                            break;
                        case 'pnlAssignments.init':
                            //This gets things ready for the assignments panel, like recalculating buckets if necessary
                            Schedule.initAssignments(scheduleParms, ds.scheduleTasks.si);
                            break;
                        case 'linkSelected':
                            selectedTasks = ds.scheduleTasks.getTaggedRows();
                            //This sets multiple predecessors
                            resp = Schedule.linkMultipleTasks(scheduleParms, selectedTasks);
                            processScheduleErrors(resp);
                            updatePredKeys(selectedTasks);
                            ds.scheduleTasks.commitTaggedItems(selectedTasks, null, null, 'untag');
                            break;
                        case 'unlinkSelected':
                            selectedTasks = ds.scheduleTasks.getTaggedRows();
                            //This removes multiple predecessors
                            resp = Schedule.unlinkTasks(scheduleParms, selectedTasks);
                            processScheduleErrors(resp);
                            updatePredKeys(selectedTasks);
                            ds.scheduleTasks.commitTaggedItems(selectedTasks, null, null, 'untag');
                            break;
                        case 'grdProjectSchedule.itemEditBegin':
                            var additionalData = [];
                            var taskPreds = Schedule.getPreds(scheduleParms, ds.scheduleTasks.si);
                            if (taskPreds) {
                                var crossProjectPreds = taskPreds.filter(function (item) {
                                    return item.CrossProject === 1;
                                });
                                if (crossProjectPreds) {
                                    for (var i = 0; i < crossProjectPreds.length; i++) {
                                        var pred = ds.predecessors.findByKey(crossProjectPreds[i].PredKey, 'PredecessorKey');
                                        if(pred){
                                            if (!Array.isArray(pred)) pred = [pred];
                                            if (pred.length > 0) {
                                                additionalData.push({TaskKey: pred[0].PredecessorKey, ProjectOrder: pred[0].ProjectOrder, TaskID: pred[0].ProjectNumber + ': ' + pred[0].TaskID, TaskName: pred[0].TaskName, TaskLevel: 0});
                                            }
                                        }
                                    }
                                }
                            }
                            ds.scheduleTasks.si.additionalData = additionalData;

                            if (u.obn(ds.scheduleTasks.si.TaskKey) <= 0) {
                                ListViews.showTab(view, 'tabEdit');
                            }
                            initTaskSettings();
                            break;


                        case 'addFiles':
                            //need to pull down the upload type
                            if (u.obn(ds.scheduleTasks.si.TaskKey) > 0) {
                                FileUpload.upload(view, ds.files, { server: System.webdavInit, Entity: 'Task', EntityKey: ds.scheduleTasks.si.TaskKey });
                            }

                            break;

                        case 'uploadComplete':
                            if (e.uploaded) {
                                if (e.uploaded.length) {
                                    for (var i = 0; i < e.uploaded.length; i++) {
                                        e.uploaded[i].TaskKey = ds.scheduleTasks.si.TaskKey;
                                        ds.attachments.addItem(e.uploaded[i]);
                                    }
                                    ds.attachments.fire();
                                    ds.files.source = [];
                                }
                            }
                            break;

                        case "deleteAttachment":
                            Notify.confirm("|24996|Are you sure you want to delete this attachment|").done(function (val) {
                                var parms = { AttachmentKey: e.actionKey };
                                self.remoteDataCall("Framework.CommonObjects.Attachments.deleteAttachment", parms, function (results) {
                                    Notify.hideBusy();
                                    if (results.errors) {
                                        alert("error");
                                    } else {
                                        ds.attachments.removeByKey(e.actionKey);
                                    }
                                });
                            });
                            break;

                        case 'openAttachment':
                            var file = ds.attachments.findByKey(e.actionKey);
                            u.downloadAttachment(e.actionKey, System.webdavInit, file.Path, file.FileName);
                            break;
                        case 'addAssignments':
                            Views.openPanel(view, "pnlAddAssignments");
                            break;
                        case 'editAssignments':
                	    case 'reassign':
                        case 'reassignAll':
                            // added to clear old selections
                            if (u.obn(ds.reassignment.si.UserKey) > 0) {
                                ds.reassignment.si.UserKey = null;
                                ds.reassignment.si.UserName = "";
                                ds.reassignment.si.Initials = "";
                            }

                            if (u.obn(ds.reassignment.si.ServiceKey) > 0) {
                                ds.reassignment.si.ServiceKey = null;
                                ds.reassignment.si.ServiceDescription = "";
                                ds.reassignment.si.ServiceCode = "";
                            }
                            var taggedRows = ds.scheduleTasks.getTaggedRows();
                            setupReassignDS(ds.taskUsers.source);
                            ds.reassignTasks.source = Schedule.getSelectedTaskAssignmentsWithParents(scheduleParms,
                                (e.action === 'reassignAll') ? $.cloneObject(ds.scheduleTasks.source, true) : taggedRows,
                                false,
                                (e.action === 'reassignAll') ? {allUnassigned: true, entity: '', assignAllTasks: true, allTagged: true} : null
                            );

                            if (e.action === 'reassign') {
                                ds.reassignTasksOnly.source = Schedule.getSelectedTaskAssignmentsWithParents(scheduleParms, taggedRows, true);
                            }

                            dp.showAssignAllTasks = (e.action === 'reassignAll');

                            if (dp.showAssignAllTasks) {
                                ds.reassignment.si.ReasignOption = 6;
                            } else {
                                ds.reassignment.si.ReasignOption = 0;
                            }

                            Views.openPanel(view, "pnlEditAssignments");

                            if (e.action === 'reassign' || e.action === 'reassignAll') {
                                ListViews.showTab(view, 'reassign');
                            }
                            break;
                        case 'copyFullTemplate':
                            Notify.showBusy('Copying template tasks');
                            //top level tasks only (not source), so that it's dropped at the highest level
                            var firstDroppedItem;
                            var dropItem = (ds.scheduleTasks.length > 0) ? ds.scheduleTasks[ds.scheduleTasks.length - 1] : null;

                            scheduleParms.keyMap = []; //initialize a new keyMap array for the drop process to bring over the template predecessors
                            //don't use source, loop through only the high level tasks, the sub tasks will come over with the parents
                            for (var i = 0; i < ds.selectedTemplateTasks.length; i++) {
                                //This adds the template task and all of it's children to the schedule
                                dropItem = Schedule.dropTemplateTask(scheduleParms, ds.selectedTemplateTasks[i], dropItem, false, true);
                                if(!firstDroppedItem) firstDroppedItem = dropItem;
                            }

                            for(var i = ds.scheduleTasks.getIndexOf(firstDroppedItem); i < ds.scheduleTasks.source.length; i++){
                                formatPredecessorSchedule(ds.scheduleTasks.source[i]);
                            }
                            ds.scheduleTasks.fire();

                            setShowTemplateDropBox();
                            Notify.hideBusy();
                            break;
                        case 'refreshTemplate':
                            var templateKey = ds.template.si ? u.obn(ds.template.si.ProjectKey) : 0;
                            if(templateKey > 0) {
                                store.templateRecent = null;
                                loadProjectTasks(templateKey);
                            }
                            break;
                        case 'frmTabPlan.save':
                        case 'frmTabActual.save':
                        case 'frmTabOther.save':
                            ds.scheduleTasks.getModifiedItems(ds.scheduleTasks, true);
                            break;
                        case 'close-query':
                            //we have to check the DS here because if all tasks have been deleted, the grid is hidden
                            //if the grid is hidden, the framework doesn't know to check the grid's DS for isDirty()
                            return (ds.scheduleTasks.hasErrors || ds.scheduleTasks.isDirty()) ? 'prompt': true;
                            break;
                        case 'close-commit':
                            //trigger the main save handler
                            fieldChangeHandler(ds.scheduleTasks.getModifiedItems(), ds.scheduleTasks, 'save');
                            break;
                		case 'frmDisplayOptions.save':
                			ds.displayOptions.si.OpenExpanded = e.formValues.OpenExpanded;
                			ds.displayOptions.refresh();

                			System.saveSession({ OpenExpanded: e.formValues.OpenExpanded }, "projectSchedule");
                			Views.close(view.views.displayOptions);
                			break;
                        case 'customRetainerDates':
                            ds.taskUsers.si.customDates = true;
                            ds.taskUsers.fire();
                            break;
                        case 'openTaskPredecessors':
                            Schedule.refreshPreds(scheduleParms);
                            var scheduleTasks = $.cloneObject(ds.scheduleTasks.source, true);
                            for (var i = 0; i < scheduleTasks.length; i++) {
                                scheduleTasks[i].tuhTaskParms = null;
                            }

                            var item = e.actionKey ? ds.scheduleTasks.findByKey(e.actionKey) : ds.scheduleTasks.si;
                            var taskPreds = Schedule.getPreds(scheduleParms, item) || [];
                            var predecessorData = $.cloneObject(taskPreds, true);
                            for (var p = 0; p < predecessorData.length; p++) {
                                predecessorData[p].PredecessorKey = predecessorData[p].PredKey; //predEdit screen expects "PredecessorKey"
                            }

                            Views.openPage(new Action("projects.schedule.predEdit", e.actionKey, {scheduleData: {data: {tasks: scheduleTasks, taskDetail: item, predecessorData: predecessorData}, allowEdit: true}}), e);
                            break;

                        /* estimates for new retainers */
                	    case 'createEstimate':
                	        createEstimate(0, e);
                            break;

                	    case 'createChangeOrder':
                	        createEstimate(1, e);
                	        break;

                	    case 'viewEstimates':
                	        viewEstimates(e);
                	        break;


                    }
            }
        }

        function updatePredKeys(taskList) {

            var newKeys;
            var taskKey;
            var preds;
            for (var i = 0; i < taskList.length; i++) {
                taskKey = u.obn(taskList[i].TaskKey);
                preds = ds.predecessors.findByKey(taskKey, 'TaskKey');
                if(preds) {
                    if (!Array.isArray(preds)) preds = [preds];

                    newKeys = [];
                    for (var p = 0; p < preds.length; p++) {
                        newKeys.push(u.obn(preds[p].PredecessorKey).toString());
                    }
                    taskList[i].AssignedPredsKeys = newKeys.join(',');
                    formatPredecessorSchedule(taskList[i]);
                }
            }
        }

        function sendSelectedNotifications(){

            var projectData = ds.project.si;
            var selectedKeys = notifySelectedTaskKeys;

            notifySelectedTaskKeys = null;

            self.remoteDataCall('sendSelectedNotifications', { projectKey: key, projectNumber: projectData.ProjectNumber, projectName: projectData.ProjectName, taskKeys: selectedKeys }, function (results) {
                if (results.errors) {
                    Notify.error(ValidationManager.getMessage(results.errors, 'scheduleTasks'));
                } else {
                    Notify.success('|24995|Selected Task Notifications Sent|');
                    ds.scheduleTasks.commitTaggedItems(selectedTasks, null, null, 'untag');
                }
            });

        }

        function sendProjectNotifications(){

            sendingProjectNotifications = false;
            var projectData = ds.project.si;

            Notify.showBusy('|24987|Sending Notifications|');
            self.remoteDataCall('sendProjectScheduleNotifications', { projectKey: key, projectNumber: projectData.ProjectNumber, projectName: projectData.ProjectName, userKey: 0 }, function (results) {
                if (results.errors) {
                    Notify.error(ValidationManager.getMessage(results.errors, 'scheduleTasks'));
                } else {
                    Notify.success('|24988|Notifications Sent|');
                }
            });

        }

        function insertToDoRow() {
        	var toDosActive = ListViews.getActiveTab(view, 'tabMain').id === 'tabToDo';

        	Views.openPage(new Action("projects.todo.add", 0, { ProjectKey: ds.project.si.ProjectKey, TaskKey: ds.scheduleTasks.si.TaskKey }));
        	//not sure this really makes sense as it could be just a blank screen
        	if (!toDosActive) ListViews.showTab(view, 'tabToDo');
        }


        function reassign(selectedTasks) {
            var resp = Schedule.reassign(scheduleParms, ds.reassignment.source, selectedTasks);
            if (processScheduleErrors(resp)) {
                Views.close(view.panels.pnlEditAssignments);
            }
        }

        function setShowTemplateDropBox() {
            dp.showTemplateDropBox = (dp.sideAction === 'stdTasks') && ds.scheduleTasks.source.length === 0;
        }

        function calcColumns(fromLoad, currentTask) {
            var task = currentTask || ds.scheduleTasks.si;

            if(task && task.tuhTaskParms && task.tuhTaskParms.buckets) {
                //This causes the bucket columns to be calculated for this task
                Schedule.calcColumns(scheduleParms, task, fromLoad);
                addGridColumns(task.tuhTaskParms.buckets, task);
            }
        }

        function addGridColumns(colList, currentTask) {
            // moved this up here since it is needed when total hours is updated
            buckets = colList;

            var grid;
            var task;
            var colPercComp;
            var colActual;
            var templateColumns;
            var noBucketColumns;
            var bucketColumns;
            var defaultGridCols;

            if (dp.isRetainer) {
                grid = view.addGrid('grdAssignmentsRet');

                task = currentTask || ds.scheduleTasks.si;
                defaultGridCols = bucketColumns = noBucketColumns = 'colUserNameRet,colPercAssignedRet,colAllocatedRet';
                view.grids.grdAssignmentsRet.locked = 3;
            } else {
                grid = view.addGrid('grdAssignments');

                task = currentTask || ds.scheduleTasks.si;
                colPercComp = (task.PercCompSeparate === 1) ? 'colPercComp,' : '';
                colActual = (task.PercCompSeparate === 1) ? 'colActual,' : '';

                templateColumns = 'colUserName,colAllocated';
                noBucketColumns = templateColumns + ',colActualHours,' + colPercComp + 'colPlan,' + colActual + 'colComments';
                bucketColumns = templateColumns + ',colActualHours,' + colPercComp + 'colPlan';

                if (dp.isTemplate) {
                    grid.columns = defaultGridCols = templateColumns;
                } else {
                    defaultGridCols = noBucketColumns;
                }
            }
            if (!dp.showBuckets) {
                grid.columns = defaultGridCols;
                return; //exit if we're not showing the bucket columns
            }

            var idList = '';
            var addCols = '';
            var newCol;
            var caption;
            var dataID;
            var dataField;
            var html;
            var renderedCurrentWeek = false;
            var currentWeekHTML = '';

            if (colList.length > 1) { //if there is only one bucket, GG doesn't want to show them in the grid
                for (var i = 0; i < colList.length; i++) {
                    newCol = colList[i];
                    caption = format(newCol.startDate, 'MMM d') + ' - ' + format(newCol.endDate, 'MMM d');
                    dataID = (dp.isRetainer) ? "offsetRet_" + i.toString() : "offset_" + i.toString();

                    if (dp.isRetainer) {
                        dataField = 'RetainerRemaining_' + i.toString();
                        if (newCol.prevWeek) {
                            html =
                                '<col id="' + dataID + '" visible="true" width="12" label="' + caption + '">' +
                                '<display>' +
                                '<div class="float-right">' +
                                '<div class="pad-b-m" title="Remaining Hours">@' + dataField + ':n2</div>' +
                                '</div>' +
                                '</display>' +
                                '<editor>' +
                                '<div class="pad-s">@Offset_' + i.toString() + ':n2</div>' +
                                '<div class="pad-s pad-t-m blue" title="Actual Hours">@RetainerBucket_' + i.toString() + ':n2</div>' +
                                '<div class="pad-s pad-t-m muted" title="Remaining Hours">@' + dataField + ':n2</div>' +
                                '</editor>' +
                                '</col>';
                        } else {
                            html =
                                '<col id="' + dataID + '" visible="true" width="12" label="' + caption + '" field="Offset_' + i.toString() + '">' +
                                '<display>' +
                                '<div class="float-right">' +
                                '<div class="pad-b-m" title="Remaining Hours">@' + dataField + ':n2</div>' +
                                '</div>' +
                                '</display>' +
                                '<editor>' +
                                '<input type="number" name="Offset_' + i.toString() + '" data-clear-zero="true" data-precision="2" />' +                                
                                '<div class="pad-s pad-t-m blue" title="Project Hours">@RetainerBucket_' + i.toString() + ':n2</div>' +
                                '<div class="pad-s pad-t-m muted" title="Remaining Hours">@' + dataField + ':n2</div>' +
                                '</editor>' +
                                '</col>';
                            renderedCurrentWeek = true;
                        }
                    } else {
                        dataField = 'Offset_' + i.toString();
                        if (newCol.prevWeek) {
                            html =
                                '<col id="' + dataID + '" visible="true" width="12" label="' + caption + '">' +
                                '<display>' +
                                '<div class="float-right">' +
                                '<div class="pad-b-m">@' + dataField + ':n2</div>' +
                                '</div>' +
                                '</display>' +
                                '<editor>' +
                                '<div class="pad-s">@' + dataField + ':n2</div>' +
                                '{{if:item.ManualAdjustment && item.Actual_' + i.toString() + ' !== 0}}<div class="pad-s pad-t-m muted" title="Actual Hours">@Actual_' + i.toString() + ':n2</div>{{if:}}' +
                                '</editor>' +
                                '</col>';
                        } else {
                            //currentWeekHTML = renderedCurrentWeek ? '' : '<div class="muted pad-t-s" data-bind-visible="@ThisWeekActual > 0">Actual Hours: <span class="pad-l-s">@ThisWeekActual:n2</span></div>';
                            html =
                                '<col id="' + dataID + '" visible="true" width="12" label="' + caption + '">' +
                                '<display>' +
                                '<div class="float-right">' +
                                '<div class="pad-b-m">@' + dataField + ':n2</div>' +
                                '</div>' +
                                '</display>' +
                                '<editor>' +
                                '<input type="number" name="' + dataField + '" data-clear-zero="true" data-precision="2" />' +
                                currentWeekHTML +
                                '</editor>' +
                                '</col>';
                            renderedCurrentWeek = true;
                        }
                    }

                    addCols += html;
                    if (idList.length === 0) {
                        idList = dataID;
                    } else {
                        idList = idList + "," + dataID;
                    }
                }
            }
            if (addCols) {
                grid.addCols = addCols;
                if (dp.showBuckets) {
                    grid.columns = bucketColumns + "," + idList;
                } else {
                    grid.columns = defaultGridCols + ',' + idList;
                }
            } else {
                grid.columns = defaultGridCols;
            }
        }

        function calcLinkToAboveDisplay(item){

            if(!dp.projectScheduleEditable){
                return false;
            }

            var showLinkToAbove = false;

            if(item) {
                if (item.ProjectOrder > 1 && item.DisplayOrder > 1) {
                    showLinkToAbove = true;

                    if (item.AssignedPredsKeys) {
                        var predKeys = u.obs(item.AssignedPredsKeys).split(',');
                        if (Array.isArray(predKeys) && predKeys.length > 0) {
                            var _idx = ds.scheduleTasks.getIndexOf(ds.scheduleTasks.si);
                            if (_idx > 0 && _idx < ds.scheduleTasks.source.length) {
                                var prev = ds.scheduleTasks.source[_idx - 1];
                                if (prev) {
                                    var prevTaskKey = u.obs(prev.TaskKey);
                                    if (predKeys.some(function (item) {
                                        return (item === prevTaskKey);
                                    })) {
                                        showLinkToAbove = false;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return showLinkToAbove;
        }

        function fieldChangeHandler(item, list, kind, field) {
            switch (list.rid) {
                case 'searchTasks':
                    if (kind === 'field' && field === 'hideCompleted') {
                        hideCompleted = item.hideCompleted === 1;
                        ds.scheduleTasks.refresh();
                    }
                    if (kind === 'field' && field === 'SetName') {
                        if (item.GridColSetKey === 0) {
                            view.grids.grdProjectSchedule.columns = dp.defaultCols;
                        } else {
                            view.grids.grdProjectSchedule.columns = 'prjScheduleTask,' + ds.colSets.findByKey(item.GridColSetKey).Columns;
                        }
                        System.saveSession({ colSetKey: item.GridColSetKey }, 'projectSchedule')
                    }
                    break;
                case 'scheduleTasks':
                    switch (kind) {
                        case 'select':
                            setScheduleTaskEnabled(item);
                            calcColumns(true, item);
                            dp.showLinkToAbove = calcLinkToAboveDisplay(item);

                            if(item.rowstate && item.rowstate === 'IN'){
                                Schedule.refreshPreds(scheduleParms);
                            }
                            break;
                        case 'field':
                            //This is the main fieldChange handler for the ScheduleManager
                            var resp = Schedule.fieldChange(scheduleParms, item, field);
                            if (resp.hasErrors()) {
                                resp.addDSErrors(ds.scheduleTasks);
                            }
                            if (resp.hasNotifications()) {
                                Notify.alert(resp.getNotifications());
                            }
                            ds.scheduleTasks.fire();
                            break;
                        case 'validate':
                            //This validates a task row
                            var resp = Schedule.validateRow(scheduleParms, item);
                            if (resp.hasErrors()) {
                                resp.addDSErrors(ds.scheduleTasks);
                                ds.scheduleTasks.fire();
                            }
                            if (resp.hasNotifications()) {
                                Notify.alert(resp.getNotifications());
                            }
                            break;
                        case 'save':
                            //This validates the entire schedule before a save. Passing true for validateStructure will also cause it to validate all of the DisplayOrder, ProjectOrder, TaskLevel fields
                            var resp = Schedule.validateSchedule(scheduleParms, true);
                            processScheduleErrors(resp);

                            //This gets the arrays of deleted items that are maintained by the Schedule for use by the updateSchedule server process
                            var scheduleModItems = Schedule.getModifiedItems(scheduleParms);
                            var deletedPredecessors = scheduleModItems ? scheduleModItems.deletedPredecessors : [];
                            var deletedTaskUsers = scheduleModItems ? scheduleModItems.deletedTaskUsers : [];
                            var addedAssignments = scheduleModItems ? scheduleModItems.addedAssignments : [];
                            var deletedAssignments = scheduleModItems ? scheduleModItems.deletedAssignments : [];
                            var removeProjectUsers = scheduleModItems ? scheduleModItems.removeProjectUsers : [];
                            var eventLog = scheduleModItems ? scheduleModItems.eventLog : [];

                            //validate new assignments (in case they were just added by pushing the + button on the user list, and the user did not focus into the grid)
                            var insertedTaskUsers = ds.taskUsers.source.filter(function (item) {
                                return !item.rowstate || item.rowstate.indexOf('I') >= 0;
                            });
                            for (var itu = 0; itu < insertedTaskUsers.length; itu++) {
                                var resp = Schedule.validateRow(scheduleParms, insertedTaskUsers[itu], Schedule.TASK_USERS);
                                if (resp.hasErrors()) {
                                    resp.addDSErrors(ds.taskUsers);
                                    ds.taskUsers.fire();
                                    return;
                                }
                                if (resp.hasNotifications()) {
                                    Notify.alert(resp.getNotifications());
                                }
                            }

                            if (ds.scheduleTasks.hasErrors) {
                                Notify.error(System.localize('|24997|This schedule contains errors|'));
                                return;
                            }

                            Notify.showBusy('Saving Schedule');
                            self.remoteDataCall('updateSchedule',
                                {
                                    application: 'project.schedule.edit updateSchedule',
                                    project: ds.project.si,
                                    addedAssignments: addedAssignments,
                                    tasks: ds.scheduleTasks.source.filter(filterOutDeletedItemsForSave, item.deletedItems),
                                    deletedTasks: item.deletedItems,
                                    taskUsers: ds.taskUsers.source.filter(filterOutDeletedItemsForSave, deletedTaskUsers),
                                    deletedTaskUsers: deletedTaskUsers,
                                    predecessors: ds.predecessors.source.filter(filterOutDeletedItemsForSave, deletedPredecessors).filter(function (item) {
                                        return u.obn(item.TaskKey) !== 0
                                    }),
                                    deletedPredecessors: deletedPredecessors,
                                    removeProjectUsers: removeProjectUsers,
                                    cfData: {}, //??????????????????
                                    dirty: { 'tAssignment': 0, 'tProjectUserServices': 0 }, //???????????????????????
                                    projectUserServices: [], //??????????????????????????????
                                    auditLog: eventLog,
                                    skipCrossProjectQueue: true
                                },

                                function (results) {
                                    if (results.errors) {
                                        Notify.error(ValidationManager.getMessage(results.errors, 'scheduleTasks'));
                                    } else {
                                        Notify.success('|24454|Schedule Updated|');

                                        // Reset OrigPercComp in case the panel stays open and another call to Save is made.
                                        // Otherwise, it will appear to the server that this value changed again.
                                        // In cases where perComp was changed to 100%, this would send unnecessary TaskChangeNotifications.
                                        for (i = 0; i < ds.scheduleTasks.source.length; i++) {
                                            ds.scheduleTasks.source[i].OrigPercComp = ds.scheduleTasks.source[i].PercComp;
                                        }
                                        var keyMaps = getKeyMaps(results.data.newKeys);

                                        ds.taskUsers.commitModifiedItems(ds.taskUsers.getModifiedItems(false, false) || {}, keyMaps.tTaskUser);
                                        ds.predecessors.commitModifiedItems(ds.predecessors.getModifiedItems(false, false) || {}, keyMaps.tTaskPredecessor);

                                        //This clears the deleted item arrays and updates the keys on predecessors
                                        Schedule.commitModifiedItems(scheduleParms, keyMaps.tTask);

                                        ds.scheduleTasks.commitModifiedItems(item, keyMaps.tTask, results.errors);

                                        //call commitModifiedItems one more time if there are still dirty rows
                                        //sometimes after template tasks are copied over, some rows are still dirty
                                        var mi = ds.scheduleTasks.getModifiedItems(false, false);
                                        if(mi){
                                            ds.scheduleTasks.commitModifiedItems(mi);
                                        }


                                        if (Object.keys(results.taskChangeList).length > 0) {
                                            self.remoteDataCall('sendTaskChangeNotifications', { taskChangeList: results.taskChangeList }, function (results) {
                                                    System.notify.fire('projectUpdated', { projectKey: key });
                                            });
                                        }

                                        self.remoteDataCall('logChangeEvents', {
                                                oldProjectRow: results.oldProjectRow,
                                                newProjectRow: ds.project.si,
                                                taskUsers: ds.taskUsers.source.filter(filterOutDeletedItemsForSave, deletedTaskUsers),
                                                predecessors: ds.predecessors.source.filter(filterOutDeletedItemsForSave, deletedPredecessors).filter(function (item) {
                                                    return u.obn(item.TaskKey) !== 0
                                                }),
                                                addedAssignments: addedAssignments,
                                                oldTaskUsers: results.oldTaskUsers
                                        });

                                        self.remoteDataCall('deleteAttachmentsForDeletedTasks', {deletedTasks: item.deletedItems});

                                        loadToAssign(); //reload the team members
                                        loadToDos(); // reload to do's some can be added from template drag and drop

                                        //add to the cross project queue in the background (don't hold up the save)
                                        self.remoteDataCall('addToCrossProjectQueueIfNecessary', { projectKey: ds.project.si.ProjectKey });

                                        // and update the unapproved estimate
                                        self.remoteDataCall('updateEstimateAfterSave', { projectKey: ds.project.si.ProjectKey });

                                        //if we were sending project notifications, return to that
                                        if(sendingProjectNotifications){
                                            sendProjectNotifications();
                                        }
                                        if (notifySelectedTaskKeys && notifySelectedTaskKeys.toString().length > 0) {
                                            sendSelectedNotifications();
                                        }
                                    }
                                });
                            break;
                        case 'new':
                            var prev;

                            if (ds.scheduleTasks.source.length > 0) {
                                prev = ds.scheduleTasks.source[ds.scheduleTasks.source.length - 1];
                            }
                            //This adds a task and sets all of its defaults
                            Schedule.addTask(scheduleParms, prev, item);
                            break;
                        case 'deleteBatchMode':
                            deleteTasks([item]);
                            break;
                    }
                    break;
                case 'taskUsers':
                case 'reassignTasks':
                    switch (kind) {
                        case 'field':
                            //This is the main fieldChange method for the Schedule. Passing in TASK_USERS tells it that the item is from the task user records
                            var resp = Schedule.fieldChange(scheduleParms, item, field, Schedule.TASK_USERS);

                            if(dp.isRetainer){
                                //reset bucket data if dates change. clear it out if the User or Service Changed until we load the new data
                                setupRetainerData(ds.scheduleTasks.si, [item], (field === 'ServiceDescription' || field === 'UserName'));

                                //if the User or Service changed, load up the data for the new User/Service
                                if (field === 'ServiceDescription' || field === 'UserName') {
                                    if(item.ServiceKey > 0 && item.UserKey > 0) {
                                        self.remoteDataCall('getRetainerBucketForAssignment', {projectKey: key, taskUserKey: item.TaskUserKey, userKey: item.UserKey, serviceKey: item.ServiceKey}, function (results) {
                                            if (!results.errors) {
                                                setupRetainerData(ds.scheduleTasks.si, [item], false, results.data.retainerBuckets, results.data.retainerActuals);
                                            }
                                        });
                                    }
                                }
                            }

                            if (resp.hasErrors()) {
                                resp.addDSErrors(ds.taskUsers);
                                ds.taskUsers.fire();
                            }
                            if (resp.hasNotifications()) {
                                Notify.alert(resp.getNotifications());
                            }
                            break;
                        case 'validate':
                            //This will validate the task user row. Passing in TASK_USERS tells it that the item is from the task user records
                            var resp = Schedule.validateRow(scheduleParms, item, Schedule.TASK_USERS);
                            if (resp.hasErrors()) {
                                resp.addDSErrors(ds.taskUsers);
                                ds.taskUsers.fire();
                            }
                            if (resp.hasNotifications()) {
                                Notify.alert(resp.getNotifications());
                            }
                            break;
                        case 'deleteBatchMode':
                            //This removes an assignment
                            Schedule.removeTaskUser(scheduleParms, item);
                            break;
                        case 'changes-commit':
                            //This rollsup the actuals to the task level
                            Schedule.rollupActuals(scheduleParms, item);
                            break;
                        case 'new':
                            //This sets the assignment defaults
                            Schedule.taskUserDefaults(scheduleParms, item);
                            break;
                    }
                    break;
                case 'predecessors':
                    switch (kind) {
                        case 'new':
                            item.Type = 'FS';
                            item.Lag = 0;

                            //default the project on to the row for use by cross-project preds
                            item.ProjectKey = ds.project.si.ProjectKey;
                            item.ProjectNumber = ds.project.si.ProjectNumber;
                            item.ProjectName = ds.project.si.ProjectName;

                            break;
                        case 'field':
                            var newKeys = [];
                            for (var i = 0; i < list.length; i++) {
                                newKeys.push(u.obn(list[i].PredecessorKey).toString());
                            }
                            ds.scheduleTasks.si.AssignedPredsKeys = newKeys.join(',');

                            switch (field){
                                case 'Lag':
                                    if(!item.PredecessorKey) return;
                                    ds.scheduleTasks.itemUpdated('U', ds.scheduleTasks.si);
                                    //no break, continue below
                                case 'TaskName':
                                    //set the cross project flag on the item
                                    item.CrossProject = (item.ProjectKey !== ds.project.si.ProjectKey) ? 1 : 0;

                                    ds.predecessors.clearError(null, item);
                                    if (item.CrossProject === 1) {
                                        //add the PlanComplete and PlanDuration information for the Cross-Project Pred
                                        Schedule.addCrossProjectPredInformation(scheduleParms, item.PredecessorKey, item.PlanComplete, item.PlanDuration);

                                        self.remoteDataCall('validateCrossProject', {predTaskKey: item.PredecessorKey, predProjectKey: item.ProjectKey, currentProjectKey: ds.project.si.ProjectKey}, function (results) {
                                            if (results.errors) {
                                                Notify.error(ValidationManager.getMessage(results.errors, 'scheduleTasks'));
                                            } else {
                                                var validateTaskResponse = results.validateTaskResponse;
                                                if(!validateTaskResponse.isValid){
                                                    if (validateTaskResponse.notScheduleTask) {
                                                        ds.predecessors.addError(System.localize('|26974|The cross-project task is not a schedule task and cannot be a predecessor|'), null, item);
                                                    }
                                                    if (validateTaskResponse.constraintIsDurationOfProject) {
                                                        ds.predecessors.addError(System.localize('|26975|The cross-project task constraint is Duration of Project and cannot be used as a predecessor|'), null, item);
                                                    }

                                                    item.PredecessorKey = null;
                                                    item.TaskID = null;
                                                    item.TaskName = null;
                                                }

                                                var checkResponse = results.checkResponse;
                                                if(!checkResponse.isValid){
                                                    var err = System.localize('|26976|This predecessor could not be used because it creates a circular relationship with project |') + checkResponse.circularProjectNumber + System.localize('|26977| and Task |') + checkResponse.circularTaskName;
                                                    ds.predecessors.addError(err, null, item);

                                                    item.ProjectKey = null;
                                                    item.ProjectNumber = null;
                                                    item.ProjectName = null;

                                                    item.PredecessorKey = null;
                                                    item.TaskID = null;
                                                    item.TaskName = null;
                                                }

                                                ds.predecessors.fire();

                                                fieldChangeHandler(ds.scheduleTasks.si, ds.scheduleTasks, 'field', 'AssignedPreds');
                                                formatPredecessorSchedule(ds.scheduleTasks.si);
                                                ds.scheduleTasks.fire();
                                            }
                                        });
                                        ds.predecessors.fire();
                                        return;
                                    }

                                    fieldChangeHandler(ds.scheduleTasks.si, ds.scheduleTasks, 'field', 'AssignedPreds');
                                    formatPredecessorSchedule(ds.scheduleTasks.si);
                                    ds.scheduleTasks.fire();
                                    break;
                            }
                            break;
                        case 'state':
                        case 'deleteBatchMode':
                            if (item.rowstate.indexOf('D') >= 0) {
                                //item has been deleted
                                var removeKey = item.PredecessorKey.toString();
                                var predKeys = ds.scheduleTasks.si.AssignedPredsKeys ? ds.scheduleTasks.si.AssignedPredsKeys.split(',') : [];
                                var newKeys = [];
                                for (var i = 0; i < predKeys.length; i++) {
                                    if (predKeys[i] !== removeKey) {
                                        newKeys.push(predKeys[i]);
                                    }
                                }
                                ds.scheduleTasks.si.AssignedPredsKeys = newKeys.join(',');
                                fieldChangeHandler(ds.scheduleTasks.si, ds.scheduleTasks, 'field', 'AssignedPreds');
                                formatPredecessorSchedule(ds.scheduleTasks.si);
                                ds.scheduleTasks.fire();
                            }
                            break;
                        case 'select':
                            var excludeList = [ds.scheduleTasks.si.TaskKey];
                            var predKeys = ds.scheduleTasks.si.AssignedPredsKeys ? ds.scheduleTasks.si.AssignedPredsKeys.split(',') : [];
                            for (var i = 0; i < predKeys.length; i++) {
                                excludeList.push(predKeys[i]);
                            }
                            item.excludeTaskList = excludeList;
                            break;
                    }
                    break;
                case 'template':
                    switch (kind) {
                        case 'field':
                            switch (field) {
                                case 'ProjectName':
                                    loadProjectTasks(item.ProjectKey);
                                    break;

                            }
                            break;
                    }
                    break;
                case 'printSettings':
                    switch (kind) {
                        case 'field':
                            switch (field) {
                                case 'PrintOption':
                                case 'includeAssignedUsers':
                                    setPrintOptionView();
                                    break;
                            }
                            break;
                    }
                    break;
                case 'todoItems':
                    switch (kind) {
                        case 'new':
                            item.ProjectKey = key;
                            item.TaskKey = ds.scheduleTasks.si.TaskKey;
                            item.Completed = 0;
                            item.CompletedName = openText;
                            break;

                        case 'save':
                            var data = item.insertedItems.concat(item.updatedItems);

                            //set StatusName to '' if it's null so that it's grouped under the existing ToDos that don't have a status
                            for (var i = 0; i < data.length; i++) {
                                data[i].StatusName = u.obs(data[i].StatusName);
                            }

                            self.remoteDataCall('updateToDo', { projectKey: key, todos: data }, function (results) {
                                if (results.errors) {
                                    Notify.error(ValidationManager.getMessage(results.errors, 'activity'));
                                } else {
                                    ds.todoItems.commitModifiedItems(item, results.data.keyMap);

                                    var openCount = 0;
                                    for (var j = 0; j < ds.todoItems.source.length; j++) {
                                        if(u.obn(ds.todoItems.source[j].TaskKey) === ds.scheduleTasks.si.TaskKey && u.obn(ds.todoItems.source[j].Completed) === 0){
                                            openCount++;
                                        }
                                    }

                                    ds.scheduleTasks.si.OpenToDos = openCount;
                                }
                            });


                            var deleteData = item.deletedItems[0];
                            if (deleteData) {
                                self.remoteDataCall('Modules.Projects.Production.deleteToDo', { ActivityKey: deleteData.ActivityKey, ProjectKey: deleteData.ProjectKey, TaskKey: deleteData.TaskKey }, function (results) {
                                    if (results.data.deleted) {
                                        ds.todoItems.commitModifiedItem(deleteData, results.data.ActivityKey);
                                    } else {
                                        Notify.error(results.errors[0].message);
                                    }
                                });
                            }

                            break;
                        case 'field':
                            switch (field) {
                                case 'StatusName':
                                    var statusItem = ds.activityStatus.findByKey(item.ActivityStatusKey);
                                    if(statusItem){
                                        if(statusItem.Completed === 1){
                                            item.Completed = 1;
                                            item.MarkedCompleted = 1;
                                        }
                                    }
                                    break;
                                case 'Completed':
                                    if(item.Completed === 1){
                                        item.CompletedName = completedText;
                                    }else{
                                        item.CompletedName = openText;
                                    }
                                    break;
                            }

                            //    break;
                    } // case todos
                    break;
                case 'toAssignList':
                    switch (kind) {
                        case 'field':
                            switch (field) {
                                case 'Hours':
                                    item.tagged = 1;
                                    //ds.toAssignList.fire();
                                    break;
                            }
                            break;
                    }
                    break;
                case 'searchAssigned':
                    switch (kind) {
                        case 'field':
                            if (field === 'filterUserServices') {
                                filterUserServices();
                            }
                            break;
                    }
                    break;
                case 'reassignment':
                    switch (kind) {
                        case 'field':
                            var taggedRows = ds.scheduleTasks.getTaggedRows();
                            var loadList = false;
                            var reassignFilter;
                            switch (field) {
                                case 'ReasignOption':
                                case 'UserName':
                                case 'ServiceDescription':
                                    loadList = true;
                                    switch (item.ReasignOption) {
                                        case 1: //Assign a person to a service
                                        case 4: //Replace a service with a different service
                                            if (item.ServiceKey > 0) {
                                                // added a check to make sure service is in the selectable list
                                                var validService = ds.projectService.findByKey(item.ServiceKey, 'k');
                                                if (validService) {
                                                    reassignFilter = { entity: 'ServiceKey', key: item.ServiceKey };
                                                } else {
                                                    item.ServiceKey = null;
                                                    item.ServiceDescription = "";
                                                    item.ServiceCode = "";
                                                }
                                                if (!reassignFilter) reassignFilter = {};
                                                if (field === 'ServiceDescription') reassignFilter.allTagged = true;
                                            }
                                            break;
                                        case 2: //Replace a person with a different person
                                        case 3: //Remove a person
                                            if (item.UserKey > 0) {
                                                // added a check to make sure user is in the selectable list
                                                var validUser = ds.projectUsers.findByKey(item.UserKey, 'k');
                                                if (validUser) {
                                                    reassignFilter = { entity: 'UserKey', key: item.UserKey };
                                                } else {
                                                    item.UserKey = null;
                                                    item.UserName = "";
                                                    item.Initials = "";
                                                }
                                                if (!reassignFilter) reassignFilter = {};
                                                if (field === 'UserName') reassignFilter.allTagged = true;
                                            }
                                            break;
                                        case 5: //Remove assignment
                                            if (item.UserKey > 0) {
                                                // added a check to make sure user is in the selectable list
                                                var validUser = ds.projectUsers.findByKey(item.UserKey, 'k');
                                                if (validUser) {
                                                    reassignFilter = {entity: 'UserKey', key: item.UserKey};
                                                } else {
                                                    item.UserKey = null;
                                                    item.UserName = "";
                                                    item.Initials = "";
                                                }
                                                if (!reassignFilter) reassignFilter = {};
                                                if (field === 'UserName') reassignFilter.allTagged = true;
                                            } else {
                                                if (item.ServiceKey > 0) {
                                                    // added a check to make sure service is in the selectable list
                                                    var validService = ds.projectService.findByKey(item.ServiceKey, 'k');
                                                    if (validService) {
                                                        reassignFilter = {entity: 'ServiceKey', key: item.ServiceKey};
                                                    } else {
                                                        item.ServiceKey = null;
                                                        item.ServiceDescription = "";
                                                        item.ServiceCode = "";
                                                    }
                                                    if (!reassignFilter) reassignFilter = {};
                                                    if (field === 'ServiceDescription') reassignFilter.allTagged = true;
                                                }
                                            }
                                            break;
                                        case 6: //All unassigned
                                            reassignFilter = {allUnassigned: true};
                                            break;
                                    }
                                    break;
                            }
                            if (loadList) {
                                if (dp.showAssignAllTasks) {
                                    if (!reassignFilter) reassignFilter = {entity: ''};
                                    reassignFilter.assignAllTasks = true;

                                    var taskList = Schedule.getSelectedTaskAssignmentsWithParents(scheduleParms, $.cloneObject(ds.scheduleTasks.source, true), false, reassignFilter, ds.reassignTasks.getTaggedRows('TaskUserKey'));
                                    //if tasks were previously tagged, tag them again
                                    var listTaskKey;
                                    var taskItem;
                                    for (var t = 0; t < taskList.length; t++) {
                                        listTaskKey = u.obn(taskList[t].TaskKey);
                                        taskItem = ds.reassignTasks.findByKey(listTaskKey, 'TaskKey');
                                        if (taskItem && taskItem.tagged) {
                                            taskList[t].tagged = 1;
                                        }
                                    }
                                    ds.reassignTasks.source = taskList;
                                } else {
                                    ds.reassignTasksOnly.source = Schedule.getSelectedTaskAssignmentsWithParents(scheduleParms, taggedRows, true, reassignFilter);
                                }

                            }
                            break;
                    }
                    break;
            }
        }

        function filterOutDeletedItemsForSave(item) {
            return !this.some(function (element) { return element === item });
        }

        function filterUserServices(){

            if(ds.searchAssigned.si.filterUserServices === 1){
                ds.toAssignList.source = userServices;
            }else{
                ds.toAssignList.source = services;
            }
        }

        function getKeyMaps(newKeys) {

            var map = {};

            var item;
            for (var i = 0; i < newKeys.length; i++) {
                item = newKeys[i];
                if (!map[item.Entity]) map[item.Entity] = [];
                map[item.Entity].push(item);
            }
            return map;
        }

        function deleteTasks(tasks) {
            //This deletes the selected tasks
            processScheduleErrors(Schedule.deleteTasks(scheduleParms, tasks));
        }

        function completeTasks(tasks) {

            view.grids.grdProjectSchedule.hideEditRow();

            if (tasks.length > 0) {
                //This marks the selected tasks complete
                Schedule.completeTasks(scheduleParms, tasks);
            }
        }

        function openAssignmentPanel(taskKey) {

            var task = ds.scheduleTasks.findByKey(taskKey);
            if (task) {
                dp.showAssignmentDropBox = !task.Assigned;
                calcColumns(true, task);
                Views.openPanel(view, 'pnlAssignments');
            }
        }

        function loadTemplates() {
            return self.remoteDataCall('getTemplateEditData', { loaded: System.loaded.scheduleTemplateEdit, projectKey: ds.project.si.ProjectKey }, function (results) {
                view.grids.grdProjectSchedule.showPlugin = (dp.sideAction === 'showGantt');
                ds.template.source = [];
                ds.template.refresh();
                if (results.errors) {
                    Notify.error(ValidationManager.getMessage(results.errors, 'schedule'));
                }

                if (!System.loaded.scheduleTemplateEdit) {
                    //load in rights and preferences
                    System.addUserSettings(results.data.init);
                    System.loaded.scheduleTemplateEdit = true;
                }

                var templateData = {};
                templateData.ProjectKey = u.obn(System.session.template_edit_projectkey);
                templateData.ProjectNumber = u.obs(System.session.template_edit_projectnumber);
                templateData.ProjectName = u.obs(System.session.template_edit_projectname);
                ds.template.source = templateData;
                if (templateData.ProjectKey > 0) {
                    loadProjectTasks(templateData.ProjectKey);
                }
            });
        }


        function loadAttachments() {
            return self.remoteDataCall('getAttachments', { projectKey: key }, function (results) {
                ds.attachments.source = results.data.attachments;
            });
        }

        function loadProjectTasks(projectKey) {
            if (projectKey === 0) {
                return;
            }

            ds.selectedTemplateTasks.source = [];
            ds.selectedTemplateTasks.refresh();

            if (store.templateRecent) {
                var isCurrentProject = false;
                for (var i = 0; i < store.templateRecent.length; i++) {
                    // test first one if the current projectKey matches just load data from cache
                    if (u.obn(ds.template.si.ProjectKey) === u.obn(store.templateRecent[i].ProjectKey)) {
                        ds.selectedTemplateTasks.source = store.templateRecent;
                        ds.selectedTemplateTasks.refresh(true);

                        ds.templateTaskUsers.source = store.templateRecentTaskUsers;
                        ds.templateTaskPreds.source = store.templateRecentTaskPreds;

                        //This tells the ScheduleManager which template predecessors and assignments go along with the template that is currently selected.
                        //We need to call this every time a different template is selected, so that predecessors and assignments can be brought over correctly
                        Schedule.setSelectedTemplate(scheduleParms, ds.templateTaskUsers, ds.templateTaskPreds);

                        isCurrentProject = true;
                        break;
                    } else {
                        break;
                    }
                }
                if (isCurrentProject) {
                    return;
                }
            }
            self.remoteDataCall('getProjectTemplate', { projectKey: projectKey }, function (results) {
                if (results.errors) {
                    Notify.error(ValidationManager.getMessage(results.errors, 'taskUsers'));
                } else {

                    if (u.obn(ds.template.si.ProjectKey) !== 0) {
                        System.saveSession({ template_edit_projectkey: ds.template.si.ProjectKey, template_edit_projectname: ds.template.si.ProjectName, template_edit_projectnumber: ds.template.si.ProjectNumber });
                    }
                    ds.selectedTemplateTasks.source = results.data.projectTemplateTasks;
                    ds.templateTaskUsers.source = results.data.projectTemplateTaskUsers;
                    ds.templateTaskPreds.source = results.data.projectTemplateTaskPreds;

                    //This tells the ScheduleManager which template predecessors and assignments go along with the template that is currently selected.
                    //We need to call this every time a different template is selected, so that predecessors and assignments can be brought over correctly
                    Schedule.setSelectedTemplate(scheduleParms, ds.templateTaskUsers, ds.templateTaskPreds);

                    store.templateRecent = results.data.projectTemplateTasks;
                    store.templateRecentTaskUsers = results.data.projectTemplateTaskUsers;
                    store.templateRecentTaskPreds = results.data.projectTemplateTaskPreds;
                    ds.setStorage(store);
                    ds.selectedTemplateTasks.refresh(true);
                }
            });
        }

        function updateTaskID(hdd, task, parentTask) {
            //This will set the taskID for the task
            Schedule.setTaskNumbers(scheduleParms, task, parentTask ? parentTask.TaskID : '', task.DisplayOrder);
        }

        function updateEditableState(forceReadOnly) {

            if(forceReadOnly){
                view.grids.grdToDos.editmode = '';
                dp.projectScheduleEditable = false;
                view.grids.grdProjectSchedule.editmode = '';
                view.grids.grdProjectSchedule.selectable = false;
                return;
            }

            view.grids.grdToDos.editmode = System.rights.prjEditToDos ? 'int|ins|del' : '';

            if ((System.rights.prjedittasks && (System.rights.prjUnlockLocked || ds.project.source.ScheduleLockedByKey === 0 || ds.project.source.ScheduleLockedByKey === System.user.userKey))) {
                dp.projectScheduleEditable = true;
            } else {
                dp.projectScheduleEditable = false;
            }

            if(dp.projectScheduleEditable){
                view.grids.grdProjectSchedule.editmode = Views.displayMode !== 'mobile' ? 'int|ins|del' : '';
                view.grids.grdProjectSchedule.selectable = true;
            }else{
                view.grids.grdProjectSchedule.editmode = '';
                view.grids.grdProjectSchedule.selectable = false;
            }
        }

        function moveTaskIn(moveTask, newSummaryTask) {

            if(!newSummaryTask) return;

            //if this is a new row, remove the "N" because now this row has been "edited"
            if (moveTask.rowstate) moveTask.rowstate = moveTask.rowstate.replace('N', '');

            view.grids.grdProjectSchedule.hideEditRow();

            //This gets the parent task of the one passed in
            var oldParentTask = Schedule.getParentTask(scheduleParms, moveTask);

            ds.scheduleTasks.addItem(moveTask, 'child', newSummaryTask);

            //This will process the scheduling logic to handle the move to the new location in the schedule
            processScheduleErrors(Schedule.afterMoveTask(scheduleParms, moveTask, oldParentTask));
        }

        function moveTaskOut(moveTask) {

            //if this is a new row, remove the "N" because now this row has been "edited"
            if (moveTask.rowstate) moveTask.rowstate = moveTask.rowstate.replace('N', '');

            view.grids.grdProjectSchedule.hideEditRow();

            //This gets the parent task of the one passed in
            var oldParentTask = Schedule.getParentTask(scheduleParms, moveTask);

            if(!oldParentTask) return; //moveTask is already at the top level

            var nextTaskSibling = DataManager.getNextSibling(ds.scheduleTasks, moveTask);
            var nextParentSibling = oldParentTask ? DataManager.getNextSibling(ds.scheduleTasks, oldParentTask) : null;

            if (nextTaskSibling) {
                //if the task has a task below it, then you're essentially moving the task below it "in"

                //This will return false if the referenceTask has assignments, so that we can ask if it's OK to remove the assignments
                if (!Schedule.isDropAsChildAllowed(scheduleParms, moveTask)) {
                    Notify.confirm(System.localize('|24620|Is it OK to delete the assigned users from the new parent task?|'), false).done(function (val) {
                        //This will remove all users assigned to this task
                        Schedule.removeTaskAssignedUsers(scheduleParms, moveTask);
                        moveTaskIn(nextTaskSibling, moveTask);
                    });
                    return;
                }
                moveTaskIn(nextTaskSibling, moveTask);
                return;
            } else if (nextParentSibling) {
                ds.scheduleTasks.addItem(moveTask, 'before', nextParentSibling);
            } else {
                ds.scheduleTasks.addItem(moveTask, 'after', oldParentTask);
            }

            //This will process the scheduling logic to handle the move to the new location in the schedule
            processScheduleErrors(Schedule.afterMoveTask(scheduleParms, moveTask, oldParentTask));
        }

        function duplicateTask(copyTask, dropTask, dropAsChild) {
            view.grids.grdProjectSchedule.hideEditRow();

            //This will copy the specified task
            Schedule.copyTask(scheduleParms, copyTask, dropTask, dropAsChild);
        }

        function insertBelowTask(task) {

            view.grids.grdProjectSchedule.hideEditRow();

            var item = {TaskKey: ds.scheduleTasks.getNextKey(), SummaryTaskKey: task.TaskKey };

            Schedule.addTask(scheduleParms, task, item);
            ds.scheduleTasks.addItem(item, 'after', task);
        }

        function useGridAdd() {
        	var grid = view.grids.grdToDos;
        	DataGrid.addNewRow(grid);
        }

        function refreshEstimateStatus() {
            // the purpose of this function is to refresh the menu for the estimates, if estimates are deleted, created, unapproved, approved
            return self.remoteDataCall('getEstimateStatus', { projectKey: key }, function (results) {

                if (results.errors) {
                    // This function does not return any error, so that would be an unexpected error
                    Notify.error(ValidationManager.getMessage(results.errors, 'scheduleTasks'));
                } else {
                    // this controls the menu for the estimates linked to a retainer
                    dp.estimateCount = u.obn(results.data.hasEstimates); // this is also a count of estimate
                    dp.approvedEstimateCount = u.obn(results.data.hasApprovedEstimates);
                    dp.estimateKey = u.obn(results.data.estimateKey); // if only 1 estimate, go directly to it

                    // also update the OrigHours (i.e Budget Hours), they may have changed after approving some estimates
                    var taskUsers = results.data.projectTaskUserData;
                    var taskUserKey = 0;
                    if (taskUsers) {
                        for (var i = 0; i < taskUsers.length; i++) {
                            taskUserKey = taskUsers[i].TaskUserKey;
                            var tu = ds.taskUsers.findByKey(taskUserKey);
                            if (tu) {
                                tu.OrigHours = u.obn(taskUsers[i].OrigHours);
                            }
                        }
                        ds.taskUsers.fire();
                    }
                }
            });
        }

        function createEstimate(changeOrder, e) {
            // if the schedule is dirty, save first
            var modifiedItems = ds.scheduleTasks.getModifiedItems();
            if (modifiedItems) {
                fieldChangeHandler(modifiedItems, ds.scheduleTasks, 'save', null);
            }
            Views.openPage(new Action("projects.estimates.add", 0, {}, { entity: 'tProject', entityKey: key, CO: changeOrder }), e);
        }

        function viewEstimates(e) {
            // if the schedule is dirty, save first
            var modifiedItems = ds.scheduleTasks.getModifiedItems();
            if (modifiedItems) {
                fieldChangeHandler(modifiedItems, ds.scheduleTasks, 'save', null);
            }

            if (dp.estimateCount === 1) {
                // if only 1 do not show the list
                Views.openPage(new Action("projects.estimates.edit", dp.estimateKey, {}));
            } else {
                Views.openPage(new Action("projects.estimates.list", key, {}));

            }
        }

        function unload() {
            self = ds = dp = view = options = null;
        }
        self.load = load;
        self.unload = unload;
        self.actionTopicHandler = actionTopicHandler;
        self.fieldChangeHandler = fieldChangeHandler;
        return self;

    }
})(jQuery);